Ti.API.warn("functions.javascript LOADED");
// END CONSTANTS
var menuStyle;
//grid, panel, thumb

var messageInbox;

var isHome = false;
var resDir;
var uuid;
var is_android;
var ExtDir;
var vars;
var pages = [];
var interstital_ad_pages;
var moduleBgImg;
var deviceWidth;
var scaleFactor;
var deviceHeight;
var isSetting = false;
var statusBar;
var mainWindowWidth;
var mainWindowHeight;
var adWindowHeight;
var myCurrentWindow;
var opacity;
var radius;
var border;
var padding;
var buttonHeight;
var iconSize;
var buttonFontSize;
var homeButtonSize;
var col_back;
var col_accent;
var col_text;
var col_title;
var new_col;
var homeBtn;
var ads_on;
var isVibration;
var isSound;
var titlefont;
var rowMargin;
var baseTextSize;
var defaultTextSize;
var titleSize;
var titleColor;
var descSize;
var descColor;
var dateSize;
var dateColor;
var imageSize;
var tableOpacity;
var tableBgColor;
var tableBgColor_semi;
var tableBorder;
var tableRadius;
var actInd;
var adWebView;
var dateFormat;
var pageviews;
var dayOfWeek;
// chatVar
var removListen;

var titleBar;
var titleLabel;

// To use fontAwesome (required the IconicFont.js)
var IconicFont = require('/lib/IconicFont'),
    iconicFont = new IconicFont({
	font : '/lib/FontAwesome'
});

(function() {
	var global = {};

	// version 1.0 - created for launch
	resDir = Titanium.Filesystem.resourcesDirectory;
	uuid = Titanium.App.Properties.getString("uuid", '');
	//uuid is set on app.js
	is_android = false;
	ExtDir;

	is_home = false;
	// start if off false, then home.js sets it to be TRUE on focus...

	//assume iphone or ipad
	Ti.API.info("Platform: " + Titanium.Platform.osname);
	if (Titanium.Platform.osname == 'android') {
		is_android = true;
		ExtDir = Titanium.Filesystem.externalStorageDirectory;
	} else {
		ExtDir = Titanium.Filesystem.applicationDataDirectory;
	}

	Ti.API.warn("reading VARS from stored property");
	vars = JSON.parse(Titanium.App.Properties.getString("vars"));
	Ti.API.warn("VARS object: " + typeof(vars));
	Ti.API.warn("PAGES subobject: " + typeof(vars.pages));

	global.vars = vars;
	vars.teamshort = vars.project_title;
	if (vars.published != 'undefined' && vars.published != null && vars.published == false) {
		pages = [];
	} else {
		pages = vars.pages;
		global.pages = pages;
	}

	// now this will decide to interstital ad
	interstital_ad_pages = vars.interstital_ad_pages;

	var win = fantasticWin;
	win.orientationModes = [Titanium.UI.PORTRAIT, Titanium.UI.UPSIDE_PORTRAIT];
	//-----platform and sizing variables
	defaultWidth = 320;
	//the base size of standard handset iphone (that apps were designed for)

	deviceWidth = Titanium.Platform.displayCaps.platformWidth;
	scaleFactor = deviceWidth / defaultWidth;

	Ti.API.warn("scaleFactor: " + scaleFactor)

	deviceHeight = Titanium.Platform.displayCaps.platformHeight;

	statusBar = 20;
	//default for ios
	if (is_android)
		statusBar = Math.round((25 * Titanium.Platform.displayCaps.dpi) / 160);
	//default

	mainWindowWidth = deviceWidth;
	mainWindowHeight = deviceHeight - statusBar;
	//excluding the top menu

	menuStyle = ( typeof vars.menu_style != "undefined" && vars.menu_style != "") ? vars.menu_style : "grid";
	//assign based on vars, or default to "grid"
	// !!!! FOR TESTING ONLY !!!!!!!! //
	// HERE YOU CAN OVERRIDE THE MENU STYLE VARIABLE FOR MANUALLY TESTING DIFFERENT STYLES: "grid", "panel", "thumb"
	// menuStyle = "panel";
	// EDN TESTING CODE //

	ads_on = vars.ads_on;
	var ads_on = 0;  //manual override to disable all ads - DH, Aug 12/18

	adWindowHeight = 50 * scaleFactor;
	if (ads_on == 0 || (is_android == false && ads_on == 1))//if there's NO ads, OR if it's ios and supposed to show admob ads, forget it. we're not doing that at the moment, because paid ios apps don't show admob ads
		adWindowHeight = 0;

	//alert("width: " + deviceWidth + ", scalefactor: " + scaleFactor + ", adheight: " + adWindowHeight);

	opacity = 0.8;
	radius = 10 * scaleFactor;
	border = 10 * scaleFactor;
	padding = border / 2;
	buttonHeight = 35 * scaleFactor;
	iconSize = 80 * scaleFactor;

	//maybe not used??? DH

	buttonFontSize = 12 * scaleFactor;
	homeButtonSize = 40 * scaleFactor;
	if (!is_android) {
		homeButtonSize = 50;
		//toolbar is 44px on iphone and ipad, plus a bit of padding
	}

	col_back = vars.col_back;
	col_text = vars.col_text;
	col_title = vars.col_title;
	col_accent = (vars.col_accent == null) ? col_title : vars.col_accent;
	new_col = '#f22';
	homeBtn;

	isVibration = false;
	isSound = false;
	titlefont = 20 * scaleFactor;

	//default table formatting
	rowMargin = 10 * scaleFactor;

	baseTextSize = 12;
	//JUST CHANGE THIS
	defaultTextSize = baseTextSize * scaleFactor;
	titleSize = (baseTextSize + 2) * scaleFactor;
	titleColor = col_title;
	descSize = (baseTextSize - 3) * scaleFactor;
	descColor = col_text;
	dateSize = (baseTextSize - 3) * scaleFactor;
	dateColor = col_text;
	imageSize = 50 * scaleFactor;

	//var tableOpacity = vars.bg_opacity;
	//var tableBgColor = col_back;
	tableOpacity = vars.bg_opacity;
	// var tableBgColor = "rgba(" + hexToRgb(col_back).r + "," + hexToRgb(col_back).g + "," + hexToRgb(col_back).b + "," + vars.bg_opacity + ")";
	tableBgColor = "#" + decToHex(tableOpacity) + decToHex(hexToRgb(col_back).r / 255) + decToHex(hexToRgb(col_back).g / 255) + decToHex(hexToRgb(col_back).b / 255);

	tableBgColor_semi = "#aa" + decToHex(hexToRgb(col_back).r / 255) + decToHex(hexToRgb(col_back).g / 255) + decToHex(hexToRgb(col_back).b / 255);

	var tableBorder = border;
	var tableRadius = radius;
	// Define all the global variables
	// global.opacity = opacity;
	// global.radius = radius;
	// global.border = border;
	// global.padding = padding;
	// global.buttonHeight = buttonHeight;
	// global.iconSize = iconSize;
	// global.resDir = resDir;
	// global.uuid = uuid;
	// global.is_android = is_android;
	// global.ExtDir = ExtDir;
	// global.vars = vars;
	// global.scaleFactor = scaleFactor;

	// global.buttonFontSize = buttonFontSize;
	// global.homeButtonSize = homeButtonSize;
	// global.titlefont = titlefont;
	// global.rowMargin = rowMargin;
	// global.baseTextSize = baseTextSize;
	// global.defaultTextSize = defaultTextSize;
	// global.titleSize = titleSize;
	// global.descSize = descSize;
	// global.imageSize = imageSize;
	// global.vars = vars;
	// global.vars = vars;

	var adUrl = (vars.ad_url) ? vars.ad_url + '?' : "https://utils.infinitemonkeys.mobi/ads/getad.php?";

	//add parameters for admarvel & future analytics
	var admarvel_id = (Titanium.Platform.osname == 'android') ? vars.admarvel_id : vars.admarvel_id_ios;
	adUrl += 'admarvel_id=' + admarvel_id;
	adUrl += '&appid=' + Titanium.App.id;
	adUrl += '&guid=' + Titanium.App.guid;
	adUrl += '&name=' + Titanium.App.name;
	adUrl += '&version=' + Titanium.App.version;
	adUrl += '&osname=' + Titanium.Platform.osname;
	adUrl += '&osversion=' + Titanium.Platform.version;
	adUrl += '&model=' + Titanium.Platform.model;
	adUrl += '&locale=' + Titanium.Platform.locale;
	adUrl += '&deviceid=' + uuid;
	// adUrl += '&deviceid=' + Titanium.Platform.id;
	// adUrl += '&macaddress=' + Titanium.Platform.macaddress;
	adUrl += '&scale=' + scaleFactor;
	adUrl += (vars.region) ? '&region=' + vars.region : '&region=';
	adUrl += (vars.country) ? '&country=' + vars.country : '&country=';
	adUrl += (vars.keywords) ? '&keywords=' + vars.keywords : '&keywords=';
	// adUrl += (vars.age) ? '&age=' + vars.age : '&age=';
	// adUrl += (vars.gender) ? '&gender=' + vars.gender : '&gender=';
	// adUrl += (vars.postal) ? '&postal=' + vars.postal : '&postal=';
	var geo = (vars.geo) ? vars.geo : '';
	adUrl += (Titanium.App.Properties.getString("geo", '') != '') ? '&geo=' + Titanium.App.Properties.getString("geo", '') : '&geo=' + geo;

	var adBanner_url = adUrl + '&ad_type=banner';
	var adInterstial_url;
	if (vars.interstitial_ad_url == null || vars.interstitial_ad_url == 'undefined') {
		adInterstial_url = adUrl + 'ad_type=interstitial';
	} else {
		adInterstial_url = vars.interstitial_ad_url;
	}

	Titanium.API.info("adurl: " + adUrl);

	var inMobiAppWallUrl = "http://appmakr.appgalleries.inmobi.com/";

	var menuOptions = ['Message Inbox', 'More Info', 'Privacy & Terms', 'About us', 'Help', 'Cancel'];
	if (ads_on != 1)
		menuOptions = ['Message Inbox', 'More Info', 'Privacy & Terms', 'Cancel'];

	// -----------------------generic Functions

	if (!is_android) {
		win.height = deviceHeight - 20;
	}

	global.customFileExists = function(myFile) {
		Ti.API.info("checking for local file: " + myFile);
		var myFile = resDir + 'custom/' + myFile;
		var file = Titanium.Filesystem.getFile(myFile);
		return file.exists();
	};

	// check file in external directory(android) or application data directory(ios)
	global.updatedFileExists = function(myFile) {
		Ti.API.info("checking for local file: " + myFile);
		var myFile = ExtDir + 'custom/' + myFile;
		var file = Titanium.Filesystem.getFile(myFile);
		return file.exists();
	};

	if (myApp.audioPlayer != null) {
		// Ti.Media.audioSessionCategory = Ti.Media.AUDIO_SESSION_CATEGORY_PLAYBACK;
		Ti.Media.defaultAudioSessionMode = Ti.Media.AUDIO_SESSION_CATEGORY_PLAYBACK;
	}
	/**** Commented by CDN (16 Feb 2016) to keep playing sound of other app while our app loads
	 Ti.Media.defaultAudioSessionMode = Ti.Media.AUDIO_SESSION_MODE_PLAYBACK;
	 var sound = Titanium.Media.createSound({
	 url : 'functions/click.wav'
	 });****/
	// Commented by CDN to minimize android permission
	// global.vibrateAndSound = function() {
	// if (Ti.App.Properties.getBool('vibration', isVibration)) {
	// Titanium.Media.vibrate();
	// }
	// if (Ti.App.Properties.getBool('sound', isSound)) {
	// sound.play();
	// }
	// };

	global.shoutOut = function(myTitle, myMessage) {
		Ti.API.info(myTitle + ": " + myMessage);
		var a = Titanium.UI.createAlertDialog({
			title : myTitle,
			message : myMessage
		});
		a.show();
	};

	global.checkNetwork = function(silent) {
		Ti.API.info("Network.online Status: " + Titanium.Network.online);
		if (Titanium.Network.online == false) {
			if (!silent) {
				global.shoutOut(L("Oops"), L("There_seems_to_be_no_internet_connection_Some_functions_require_the_internet"));
			}
			return false;
		} else {
			return true;
		}
	};

	function checkNetwork(silent) {
		Ti.API.info("Network.online Status: " + Titanium.Network.online);
		if (Titanium.Network.online == false) {
			if (!silent) {
				global.shoutOut(L("Oops"), L("There_seems_to_be_no_internet_connection_Some_functions_require_the_internet"));
			}
			return false;
		} else {
			return true;
		}
	};

	global.urlEncode = function(s) {
		return encodeURIComponent(s).replace(/\%20/g, '+').replace(/!/g, '%21').replace(/'/g, '%27').replace(/\(/g, '%28').replace(/\)/g, '%29').replace(/\*/g, '%2A').replace(/\~/g, '%7E');
	};

	global.urlDecode = function(s) {
		return decodeURIComponent(s.replace(/\+/g, '%20').replace(/\%21/g, '!').replace(/\%27/g, "'").replace(/\%28/g, '(').replace(/\%29/g, ')').replace(/\%2A/g, '*').replace(/\%7E/g, '~'));
	};

	global.makehtml = function(stuff, basecolour, style) {
		if (basecolour === undefined) {
			basecolour = col_text;
		}
		if (style === undefined) {
			style = "html, body, p{color: " + basecolour + "; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: medium;}";
			style += "img { max-width: 100%; }";
		}
		var html_stuff = '<!DOCTYPE html><html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8"><meta name="viewport" content="width=100%, initial-scale=1.0"><style>' + style + '</style></head><body>' + stuff + '</body></html>';
		Ti.API.info(html_stuff);
		return html_stuff;
	};

	global.makeClickableHTML = function(html) {
		var head = '<!DOCTYPE html><html lang="en"> <head> <meta http-equiv="Content-Type" content="text/html; charset=utf-8"><meta name="viewport" content="width=100%, initial-scale=1.0"> <script type="text/javascript"></script></head><body>';
		//  var script = "<script>$(document).ready(function(){alert('ready'); $('a').each(function(){$(this).bind('click',function(){var theURL=this.getAttribute('href');var eventObject = new Object;var a = 'URL';eventObject[a] = theURL;Ti.App.fireEvent('openURL',eventObject);return false;});})});</script>";
		var script = "<script> var allLinks = document.links; for (var i = 0, n = allLinks.length; i < n; i++) {allLinks[i].onclick = function () { Ti.App.fireEvent('openURL',{URL:this.href}); return false;};}</script>";
		var tail = '</body> </html>';

		var newHTML = head + html + script + tail;
		Ti.API.info(newHTML);
		return newHTML
	};

	// variable used on all pages that need activity indicators
	actInd = Titanium.UI.createActivityIndicator({
		height : 50 * scaleFactor,
		width : 'auto',
		message : L("Fetching_Latest_Data"),
		// style : Titanium.UI.iOS.ActivityIndicatorStyle.DARK,
		font : {
			fontSize : 14 * scaleFactor
		},
		zIndex : 20
	});

	global.displayDefaultAd = function() {
		Titanium.API.info("just using the default ad...");
		// logIt("ad_show", "default");
		var defaultAd = Ti.UI.createImageView({
			image : "/images/default_ad.png",
			height : adWindowHeight,
			width : defaultWidth,
			bottom : 0
		});
		fantasticWin.add(defaultAd);
	};

	function displayUserAd(AdWin) {
		if (!AdWin) {
			AdWin = myCurrentWindow;
		}
		try {
			var adCode = Titanium.Utils.base64decode(vars.ad_code);
			Ti.API.info('adCode  ' + global.makehtml(adCode));

			var userAdWebView = Ti.UI.createWebView({
				html : global.makehtml(adCode),
				height : adWindowHeight,
				//width:defaultWidth,
				scalesPageToFit : true,
				bottom : 0,
				backgroundColor : 'transparent',
			});

			AdWin.add(userAdWebView);
		} catch(e) {
			Ti.API.info('Error in ads content : ' + e.message);
		}

	};

	// Implements adMob module to display ads for free app
	function displayAdMob(AdWin, AdID) {
		//removed admob functionality completely - DH, Aug 12/2018
	};

	displayAd = function(AdWin) {
		//removed ad functionality completely - DH, Aug 12/2018
	};

	global.makeAdView = function(AdWin) {
		//removed ad functionality completely - DH, Aug 12/2018
	};

	// To place the Title Bar on the top of every page (11 September 2015)
	global.addPageTitle = function(pageTitle, zlevel, myWin) {
		if (myWin == null || myWin == 'undefined') {
			myWin = myCurrentWindow;
		}

		Ti.API.info("adding Page Title to window:");
		Ti.API.info(myWin);

		if (is_android) {

			if (zlevel == null || zlevel == 'undefined') {
				zlevel = 98;
			}

			titleBar = Ti.UI.createView({
				top : 0,
				height : homeButtonSize + 5,
				backgroundColor : col_back,
			});

			titleLabel = Ti.UI.createLabel({
				text : pageTitle,
				color : col_title,
				font : {
					fontSize : titleSize + 2,
					fontWeight : 'bold',
				},
				textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
				verticalAlign : Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
			});
			titleBar.add(titleLabel);
			myWin.add(titleBar);

		} else {// for iOS
			if (zlevel == null || zlevel == 'undefined') {
				zlevel = 98;
			}

			titleBar = Ti.UI.createView({
				top : 0,
				height : homeButtonSize + 5,
				backgroundColor : col_back,
			});

			titleLabel = Ti.UI.createLabel({
				text : pageTitle,
				color : col_title,
				font : {
					fontSize : titleSize + 2,
					fontWeight : 'bold',
				},
				textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
				verticalAlign : Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
			});
			titleBar.add(titleLabel);
			myWin.add(titleBar);
		}

	};

	global.addHomeButton = function(zlevel, myWin, addAppsBtn) {
		if (menuStyle != 'grid')
			return true;
		// bypass entire fundtion because we don't need it...

		if (myWin == null || myWin == 'undefined') {
			myWin = myCurrentWindow;
		}
		Ti.API.info("adding homebutton to window:");
		Ti.API.info(myWin);

		if (is_android) {

			if (zlevel == null || zlevel == 'undefined') {
				zlevel = 99;
			}

			homeBtn = Ti.UI.createLabel({
				top : 0,
				right : 0,
				color : col_title,
				font : {
					fontSize : titleSize,
					fontFamily : iconicFont.fontfamily
				},
				text : iconicFont.icon('fa-home'),
				textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
				verticalAlign : Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
				height : homeButtonSize,
				width : homeButtonSize,
				zIndex : zlevel,
				//backgroundColor : "#333",
			});

			homeBtn.addEventListener('touchstart', function(e) {
				//homeBtn.image = "/images/selecthome_icon.png";
				homeBtn.backgroundColor = "#333";
			});

			homeBtn.addEventListener('touchend', function(e) {
				//homeBtn.image = "/images/home_icon.png";
				homeBtn.backgroundColor = "transparent";
				Ti.API.info('home');
				if (myWin.title == "LiveChat") {
					removListen();
				}
				myWin.close();
				Ti.API.info("myWin : " + myWin.title);
			});
			myWin.add(homeBtn);

		} else {//for iOS

			var flexSpace = Titanium.UI.createButton({
				systemButton : Titanium.UI.iOS.SystemButton.FLEXIBLE_SPACE
			});
			var homeBtn = Ti.UI.createLabel({
				top : 0,
				right : 0,
				color : col_title,
				font : {
					fontSize : titleSize,
					fontFamily : iconicFont.fontfamily
				},
				text : iconicFont.icon('fa-home'),
				textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
				verticalAlign : Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
				height : homeButtonSize,
				width : homeButtonSize,
				zIndex : zlevel,
				//backgroundColor : "#333",
			});

			homeBtn.addEventListener('click', function() {
				Ti.API.info("closing myWin : " + myWin.title);
				if (myWin.title == "LiveChat") {
					removListen();
				}

				myWin.close();
			});
			myWin.add(homeBtn);

		}

	};

	//-------------------------- popup menu
	doMenuOption = function(optionClicked) {
		switch(optionClicked) {
		case 'Message Inbox':
			var message_html = myApp.global.makehtml(Titanium.App.Properties.getString('message', ''), col_text);
			if (message_html != '' && message_html != 'undefined') {
				myApp.global.openHTMLWebWindow(message_html);
			} else {
				global.shoutOut(L("Message"), L("Sorry_no_messages_in_your_inbox"));
			}
			break;
		case 'More Info':
			myCurrentWindow = fantasticWin;
			myApp.global.getWebView(vars.moreinfo_url, false, "close", false, true);
			break;

		case 'Privacy & Terms':
			myCurrentWindow = fantasticWin;
			myApp.global.getWebView(resDir + "app_privacy_terms.html", false, "close", false, true);
			break;
		// case 'Recommended Apps':
		// //           winTrumpet.open();
		// //           if(is_android)
		// //               Ti.Platform.openURL(inMobiAppWallUrl);
		// //           else
		// getWebView(inMobiAppWallUrl, false, "close", false, true);
		//
		// break;
		case 'About us':
			myCurrentWindow = fantasticWin;
			myApp.global.getWebView(vars.about_us_url, false, "close", false, true);
			break;
		case 'Feedback':
			myCurrentWindow = fantasticWin;
			myApp.global.getWebView(vars.feedback_url, false, "close", true, true);
			break;
		case 'Help':
			myCurrentWindow = fantasticWin;
			myApp.global.getWebView(vars.help_url, false, "close", true, true);
			break;
		case 'Send to a Friend':
			Ti.API.warn("old send-to-friend function was here...");
			break;
		// case 'Preferences':
		// openPreferences();
		// break;
		case 'Cancel':
			break;
		}
	};


	// function openPreferences() {
	// var w = Titanium.UI.createWindow({// create the new windows & events
	// title : L("Preferences"),
	// url : "mymodules/preferences/preferences.js",
	// //      backgroundImage : resDir + "custom/default-bg.png",
	// backgroundColor : "white",
	// navBarHidden : true,
	// zIndex : 1,
	// orientationModes : [Titanium.UI.PORTRAIT]
	// });
	// //   logIt("page_open", w.url, "Preferences");
	// Ti.API.info("opening Prefs");
	// w.open();
	// }

	global.createOptionsMenu = function() {
		Titanium.API.info("creating menu functions");
		var activity = Ti.Android.currentActivity;
		fantasticWin.activity.onCreateOptionsMenu = function(e) {
			var menu = e.menu;
			for (var i = 0; i < menuOptions.length; i++) {
				var menuItem = menu.add({
					title : menuOptions[i],
					itemId : i
				});
				menuItem.addEventListener("click", function(e) {
					var optionClicked = e.source.title;
					Ti.API.info(optionClicked);
					doMenuOption(optionClicked);
					// call menu option functions
				});
			}
		};
	};

	function createIosBarButton(b_text, b_image, b_option) {
		var myView = Titanium.UI.createView({
			width : 35,
			height : 45,
			top : 0
		});

		var myButton = Titanium.UI.createButton({
			width : 25,
			height : 25,
			top : 5,
			backgroundImage : b_image,
		});

		var myImage = Titanium.UI.createButton({
			image : b_image,
			height : 30,
			width : 30,
			top : 5,
			color : "#000"
		});

		var myText = Titanium.UI.createLabel({
			text : b_text,
			bottom : 0,
			color : "#ddd",
			font : {
				fontSize : 9
			},
		});
		myView.add(myButton);
		//  myView.add(myImage);
		myView.add(myText);

		myView.addEventListener("touchend", function() {
			doMenuOption(b_option);
		});
		return myView;
	};

	global.createIosMenu = function() {
		Titanium.API.info("creating IOS menu functions");

		var flexSpace = Titanium.UI.createButton({
			systemButton : Titanium.UI.iOS.SystemButton.FLEXIBLE_SPACE
		});

		var b1 = createIosBarButton("News", "images/ios/share.png", "Message Inbox");
		var b2 = createIosBarButton("Info", "images/ios/info.png", "More Info");
		var b2a = createIosBarButton("Privacy", "images/ios/lock.png", "Privacy & Terms");
		var b3 = createIosBarButton("About", "images/ios/about.png", "About us");
		// var b4 = createIosBarButton("Apps", "images/ios/apps.png", "Recommended Apps");
		// var b5 = createIosBarButton("Share", "images/ios/sharethis.png", "Send to a Friend");
		//  var b6 = createIosBarButton("Help", "images/ios/feedback.png", "Feedback");
		var b7 = createIosBarButton("Help", "images/ios/help.png", "Help");
		// var b8 = createIosBarButton("Prefs", "images/ios/prefs.png", "Preferences");
		if (ads_on == 1) {//includes our ads
			var menuitems = [flexSpace, b1, b2, b2a, b3, b7, flexSpace];
			// var menuitems = [flexSpace, b1, b2, b3, b5, b7, b8, flexSpace];
		} else {//no ads or their ads--> no info or ads
			var menuitems = [flexSpace, b1, b2, b2a, flexSpace];
			// var menuitems = [flexSpace, b1, b2, b5, b8, flexSpace];
		}

		var toolbar1 = Titanium.UI.iOS.createToolbar({
			items : menuitems,
			bottom : 0,
			borderTop : true,
			borderBottom : false,
			translucent : true,
			barColor : '#000',
			style : Titanium.UI.iOS.SystemButtonStyle.BAR
		});
		win.add(toolbar1);

	};

	var checking_link_safety_status = 0;
	// 0=not checked, 1=checking, 2=result found - - global for safe_website checking functions

	global.getWebView = function(link, isBreakout, closeBtn, navButtons, fullSize, safebrowse) {
		var loadedBool = false;
		//alert(weather_lat);
		if (isBreakout == null || isBreakout == 'undefined') {
			isBreakout = true;
			//default value
		}
		if (closeBtn == null || closeBtn == 'undefined') {
			closeBtn = "close";
			//default value
		}
		if (navButtons == null || navButtons == 'undefined') {
			navButtons = true;
			//default value
		}
		if (fullSize == null || fullSize == 'undefined') {
			fullSize = false;
			//default value
		}
		if (safebrowse == null || safebrowse == 'undefined') {
			safebrowse = false;
			//default value
		}

		//check to see if safebrowse's even needed first
		if (vars['safebrowsing_porn'] && vars['safebrowsing_porn'] == true)
			safebrowse = "xxx";
		else if (vars['safebrowsing_malware'] && vars['safebrowsing_malware'] == true)
			safebrowse = "malware";
		else if (vars['safebrowsing_porn'] && vars['safebrowsing_porn'] == true && vars['safebrowsing_malware'] && vars['safebrowsing_malware'] == true)
			safebrowse = "all";
		else
			safebrowse = false;
		Ti.API.info('SAFEBROWSING STATUS: ' + safebrowse);

		Ti.API.info('Table bg color : ' + tableBgColor);

		Ti.API.info('browsing to: ' + link);
		var loading = false;

		var container = Titanium.UI.createView({
			top : (closeBtn == "home") ? homeButtonSize : 0,
			left : 0,
			bottom : (ads_on > 0) ? adWindowHeight : 0,
			width : Titanium.UI.FILL,
			backgroundColor : col_back,
			// backgroundColor : "blue",
			zIndex : 500
		});
		if (fullSize == true)
			container.bottom = 0;

		var view = Titanium.UI.createWebView({
			top : (closeBtn == "close") ? homeButtonSize : 0,
			right : (fullSize == false) ? padding : 0,
			left : (fullSize == false) ? padding : 0,
			borderRadius: 1,	//needed to disable hardware acceleration, which is conflicting with calendar code somehow...
			bottom : buttonHeight + padding * 2,
			backgroundColor : "#fff",
			url : "/loading.html",
			cacheMode : (is_android) ? Titanium.UI.Android.WEBVIEW_LOAD_NO_CACHE : 0
		});
		//		if (fullSize == "stoploading" || fullSize == 'calendar') {
		//			view.borderRadius = radius;
		//		}

		if (navButtons == false) {//make the window bigger if there's no nav buttons
			view.bottom = (fullSize == false) ? padding : 0;
		}

		// Refresh web view when change the device orientation
		// Titanium.Gesture.addEventListener('orientationchange', function(e) {
		// if (fullSize != 'stoploading') {
		// if (checkNetwork(true) == true) {
		// view.url = link;
		// } else {
		// view.url = "/error.html";
		// }
		// if (e.orientation == 2) {
		// container.bottom = 0;
		// view.bottom = 0;
		// } else {
		// container.bottom = (ads_on > 0) ? adWindowHeight : 0;
		// view.bottom = buttonHeight + padding * 2;
		// }
		// }
		// });

		//  view.add(actInd);
		//  actInd.show();
		view.addEventListener('beforeload', function(e) {
			//			if ( typeof weather_lat != 'undefined')
			//				view.evalJS("var lat='" + weather_lat + "';");
			//			if ( typeof weather_lon != 'undefined')
			//				view.evalJS("var lon='" + weather_lon + "';");
			if (!loading) {
				loading = true;
				//Start Activity Indicator Here
				//          actInd.show();
				setTimeout(function() {
					if (loading) {
						loading = false;
						//Hide activity indicator here
						//                  actInd.hide();

					}
				}, 3000);
			}

		});
		view.addEventListener('error', function(e) {
			//      actInd.hide();
			if (loadedBool)
				return;

			Titanium.API.info(e.message);
			view.url = "/error.html";
		});
		view.addEventListener('load', function(e) {
			loadedBool = true;
			webWindowNavButtons(view, fwdBtn, backBtn);
			//      actInd.hide();
		});

		container.add(view);

		if (checkNetwork(true) == true) {//if there's good network connection
			Titanium.API.info("setting webview url to: " + link);
			view.url = link;
			//set the url after it's added
		} else {
			view.url = "/error.html";
		}
		// logIt("getWebView_url", win.url, link);
		backBtn = Titanium.UI.createButton({
			bottom : padding,
			left : border,
			//      width : buttonHeight * 2,
			height : buttonHeight,
			font : {
				fontSize : 11 * scaleFactor,
				fontWeight : 'bold',
				//fontFamily : 'Helvetica Neue'
			},
			title : L("Back"),
			enabled : false,
			color : col_title
		});
		backBtn.addEventListener('click', function() {
			Ti.API.info('going back');
			view.goBack();
		});
		if (navButtons == true)
			container.add(backBtn);

		fwdBtn = Titanium.UI.createButton({
			bottom : padding,
			right : border,
			//      width : buttonHeight * 2,
			height : buttonHeight,
			font : {
				fontSize : 11 * scaleFactor,
				fontWeight : 'bold',
				//fontFamily : 'Helvetica Neue'
			},
			title : L("Forward"),
			enabled : false,
			color : col_title
		});

		fwdBtn.addEventListener('click', function() {
			Ti.API.info('going forward');
			view.goForward();
		});

		if (navButtons == true)
			container.add(fwdBtn);
		//different headers for platforms
		if (is_android) {

			if (isBreakout == true && safebrowse == false) {

				var breakoutBtn = Titanium.UI.createImageView({
					top : padding,
					left : border,
					width : buttonHeight,
					height : buttonHeight,
					image : "/images/new_window.png"
				});

				breakoutBtn.addEventListener('click', function() {
					Ti.API.info('opening link with system browser: ' + view.url);
					// logIt("breakout", "browser", view.url);
					Titanium.Platform.openURL(view.url);
				});
				container.add(breakoutBtn);

				// var social = getSocialButton(link, link, "", link);
				// //generic social function returns 2 buttons in view with
				// social.bottom = border;
				// container.add(social);

				Ti.Gesture.addEventListener('orientationchange', function(e) {//reposition social buttons based on orientation
					if (e.orientation == Titanium.UI.LANDSCAPE_LEFT || e.orientation == Titanium.UI.LANDSCAPE_RIGHT) {
						Ti.API.info("resizing for landscape");
						win.setHeight(deviceWidth - statusBar);
					} else {
						Ti.API.info("resizing for portrait");
						win.setHeight(deviceHeight - statusBar);
					}
				});

				view.top = view.top + buttonHeight + padding;

			}

			//			if (isBreakout == false) {
			//				view.top = 0;
			//			}

			if (closeBtn == "close") {
				var closeBtn = Titanium.UI.createButton({
					title : L("Close"),
					top : padding,
					right : border,
					width : buttonHeight * 2,
					height : buttonHeight,
					color : col_title,
					font : {
						fontSize : 12 * scaleFactor,
						fontWeight : 'bold'
					},
				});

				closeBtn.addEventListener('click', function() {
					container.hide();
				});
				container.add(closeBtn);
			} else if (closeBtn == "home") {
				//myApp.global.addHomeButton(999, null, !isBreakout);
				myApp.global.addHomeButton();
			}
		} else {//iOS
			view.scalesPageToFit = true;
			Ti.API.info("creating iOS toolbar");

			var flexSpace = Titanium.UI.createButton({
				systemButton : Titanium.UI.iOS.SystemButton.FLEXIBLE_SPACE
			});
			if (closeBtn == "close") {
				var homeBtn = Titanium.UI.createButton({
					title : L("Close"),
					style : Titanium.UI.iOS.SystemButtonStyle.BORDERED,
					top : padding,
					right : border,
					color : col_title
				});
				homeBtn.addEventListener('click', function() {
					container.animate({
						left : -deviceWidth,
						duration : 300
					}, function() {
						container.hide();
					});
				});
				container.add(homeBtn);
			} else if (closeBtn == "home") {
				// var homeBtn = Titanium.UI.createButton({
				// title : L("home"),
				// style : Titanium.UI.iOS.SystemButtonStyle.BORDERED
				// });
				// homeBtn.addEventListener('click', function() {
				// myCurrentWindow.close();
				// });
				myApp.global.addHomeButton();
			}

			var pageTitle = Titanium.UI.createLabel({
				text : "",
				width : 200,
				color : 'white',
				font : {
					fontSize : baseTextSize
				},
				textAlign : 'center'
			});

			var breakoutBtn = flexSpace;
			//default
			if (isBreakout == true && safebrowse == false) {
				Ti.API.info('isbreakout is', isBreakout);
				// var social = getSocialButton(link, link, "", link);
				// social.bottom = border;

				breakoutBtn = Titanium.UI.createButton({
					backgroundImage : "/images/new_window.png",
					height : homeButtonSize,
					width : homeButtonSize
				});

				breakoutBtn.addEventListener('click', function() {
					Ti.API.info('opening link with system browser: ' + view.url);
					// logIt("breakout", "browser", view.url);
					Titanium.Platform.openURL(view.url);
				});

				toolbarItems = [flexSpace, breakoutBtn];
			} else {
				toolbarItems = [pageTitle, flexSpace, breakoutBtn];
			}

			// create and add toolbar
			if (isBreakout != false) {
				var toolbar1 = Titanium.UI.iOS.createToolbar({
					items : toolbarItems,
					top : (closeBtn == "close") ? homeButtonSize : 0,
					zIndex : 999
				});
				container.add(toolbar1);

				view.top = view.top + buttonHeight + padding;
			}

			//			if (isBreakout == false) {
			//				view.top = 0;
			//			}

		}

		//safe browsing part. If it's turned on by the calling function.

		// if it hasn't been shut down, then add the listeners
		if (safebrowse != false) {
			Ti.API.info("safebrowsing is: " + safebrowse);
			checking_link_safety_status = 0;
			// 0=not checked, 1=checking, 2=result found

			view.addEventListener("load", function() {
				Ti.API.info('LOAD EVENT: ' + view.url);
				//for testing only
				var url = view.url;
				if (url.search("http") > -1 && checking_link_safety_status == 0) {
					checkUrl(url, view);
				} else {
					Ti.API.info("local URL - not checking: " + url);
				}
			});

			view.addEventListener("beforeload", function() {
				Ti.API.info('BEFORELOAD EVENT: ' + view.url);
				//for testing only
				var url = view.url;
				if (url.search("http") > -1 && checking_link_safety_status == 0) {
					checkUrl(url, view);
				} else {
					Ti.API.info("local URL - not checking: " + url);
				}
			});

		}

		// return container;
		myCurrentWindow.add(container);

		container.show();

	};

	function checkUrl(url, view) {
		var check_url = "https://utils.infinitemonkeys.mobi/safebrowsing.php?url=" + url;

		var safebrowsing = false;
		if (vars['safebrowsing_porn'] && vars['safebrowsing_porn'] == true)
			safebrowsing = "xxx";
		if (vars['safebrowsing_malware'] && vars['safebrowsing_malware'] == true)
			safebrowsing = "malware";
		if (vars['safebrowsing_porn'] && vars['safebrowsing_porn'] == true && vars['safebrowsing_malware'] && vars['safebrowsing_malware'] == true)
			safebrowsing = "all";

		if (safebrowsing != false) {
			check_url += "&type=" + safebrowsing;

			var json;
			var appReq = Ti.Network.createHTTPClient();

			Ti.API.info("checking URL: " + check_url);

			checking_link_safety_status = 1;
			// 0=not checked, 1=checking, 2=result found

			appReq.open('GET', check_url);

			//on load handler
			appReq.onload = function() {

				Ti.API.info("Received text: " + this.responseText);
				checking_link_safety_status = 2;
				// 0=not checked, 1=checking, 2=result found
				try {
					json = eval('(' + this.responseText + ')');
					var warning_message = global.makehtml("<h1>Warning:</h1><h2>Suspected unsafe or unacceptable content on this page. Navigation aborted.</h2><p>If you think this is an error, please contact the publisher of this app: " + vars.email + "</p>");
					if (json.error == false && json.msg != 'safe') {
						Ti.API.info('unsafe website: ' + json.msg);
						view.html = warning_message;
					} else {
						Ti.API.info('SAFE website (or error checking): ' + json);
					}
				} catch(err) {
					Ti.API.debug("error parsing response: " + err + " - " + this.responseText);
				}

			};

			//error handler
			appReq.onerror = function(e) {

				Ti.API.debug("STATUS: " + this.status);
				Ti.API.debug("TEXT:   " + this.responseText);
				Ti.API.debug("ERROR:  " + e.error);
				//alert('There was an error retrieving the remote data. Try again.');

			};

			appReq.send();

		} else {
			Ti.API.debug("NOT doing safebrowsing check: no safebrowsing addons set");
		}
	};

	function webWindowNavButtons(view, fwdBtn, backBtn) {
		if (!view.canGoForward()) {
			fwdBtn.enabled = false;
		} else {
			fwdBtn.enabled = true;
		}
		if (!view.canGoBack()) {
			backBtn.enabled = false;
		} else {
			backBtn.enabled = true;
		}
	};

	global.createContainer = function() {
		var container = Titanium.UI.createView({
			backgroundColor : 'transparent',
			top : homeButtonSize + rowMargin,
			bottom : (ads_on > 0) ? adWindowHeight + padding : padding,
			//left : border,
			//right : border
		});
		return container;
	};

	global.createLinkTable = function(link_data, bgcolor) {
		if (bgcolor == null || bgcolor == 'undefined') {
			bgcolor = col_back;
		}
		var tableView = Titanium.UI.createTableView({
			data : link_data,
			backgroundColor : bgcolor,
			top : homeButtonSize + rowMargin,
			bottom : adWindowHeight + 10,
			//left : border,
			//right : border,
			//      opacity : opacity,
			//borderRadius : radius,
			//      borderColor:col_text
			separatorColor : col_text,
			height : Ti.UI.SIZE,
			separatorInsets : {
				left : 0,
				right : 0
			}
		});

		tableView.addEventListener('click', function(e) {
			tableView.touchEnabled = false;
			var row = e.row;
			var rowdata = e.rowData;

			if (checkNetwork(false) == true) {
				if (e.rowData.external && e.rowData.external == 1) {
					Titanium.Platform.openURL(e.rowData.link);
				} else {
					// getWebView(e.rowData.link, true, "close");
					myApp.global.getWebView(e.rowData.link, true, 'close', true, false, true);
				}
			}
			setTimeout(function() {
				tableView.touchEnabled = true;
			}, 600);
		});
		return tableView;
	};

	global.breakout = function(url) {
		// logIt("breakout", win.url, url);
		Titanium.Platform.openURL(url);
	};

	// global.makehtml = function(str) {
	// 	var fontSize = 14;
	// 	if (scaleFactor > 2 && scaleFactor < 3) {
	// 		fontSize = 8;
	// 	} else if (scaleFactor > 3) {
	// 		fontSize = 4;
	// 	}
	// 	str = "<html><body style='font-size:" + fontSize * scaleFactor + "'>" + str + "</body></html>";
	// 	return str;
	// };

	// -------------Stuff for Interstital page --------------

	var tipsTitle = Ti.UI.createLabel({
		color : col_title,
		font : {
			fontSize : deviceWidth * 0.035
		},
		wordwrap : true,
		width : 'auto',
		textAlign : 'center',
		visible : false,
		height : buttonHeight - 10,
		backgroundColor : '#fff',
		borderRadius : 5
		//  borderWidth : 2.5,
		//  borderColor : 'blue'
	});
	fantasticWin.add(tipsTitle);

	//--- Show messages Entered by the publisher in the machine
	global.openHTMLWebWindow = function(message_html, btn_text, titleTxt) {//isHTML defaults to false
		btn_text = (btn_text) ? btn_text : "Continue";
		//set default value
		Ti.API.info('opening browser with html');
		var w = Titanium.UI.createWindow({
			navBarHidden : false,
			fullscreen : false,
			theme : "Theme.AppCompat.Fullscreen",
			backgroundColor : col_back
		});
		var view = Titanium.UI.createWebView({
			top : border,
			right : border,
			left : border,
			bottom : buttonHeight + border,
			backgroundColor : "transparent",
			// borderRadius : radius,
			html : message_html,
			cacheMode : (is_android) ? Titanium.UI.Android.WEBVIEW_LOAD_NO_CACHE : 0
		});
		var skipBtn;
		if (btn_text == 'Back') {

			skipBtn = Titanium.UI.createButton({
				left : 0,
				width : homeButtonSize,
				height : homeButtonSize,
				top : 0,
				color : col_title,
				font : {
					fontSize : titleSize,
					fontFamily : iconicFont.fontfamily
				},
				title : iconicFont.icon('fa-arrow-left'),
				textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
				verticalAlign : Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
				backgroundColor : 'transparant',
			});
		} else {
			skipBtn = Titanium.UI.createButton({
				title : btn_text,
				bottom : padding,
				left : border,
				right : border,
				height : deviceWidth * 0.1,
				color : col_title,
				font : {
					fontSize : buttonFontSize,
					fontWeight : 'bold',
					fontFamily : 'Helvetica Neue'
				},
			});
		}

		skipBtn.addEventListener('click', function() {
			w.close();
		});
		if (titleTxt != null || titleTxt != undefined)// Adds Title bar to this window also shifts the webview top accroding to the titlebar
		{
			myApp.global.addPageTitle(titleTxt, 99, w);
			view.top = homeButtonSize + rowMargin;
		}

		w.add(view);
		w.add(skipBtn);
		w.open();
	};

	//--- Function that will call each pageViews and apploads
	var app_loads = Ti.App.Properties.getInt('app_loads', 1);
	pageviews = Ti.App.Properties.getInt('pages_views', 0);
	global.placeholder = function() {
		//  if(app_loads == 1 && pageviews == 1) {
		//
		//      tipsTitle.top = padding;
		//      tipsTitle.right = homeButtonSize + border;
		//      tipsTitle.text = '  Back to Home-->  ';
		//      setTimeout(function(e) {
		//          tipsTitle.visible = true;
		//      }, 1000);
		//      setTimeout(function(e) {
		//          tipsTitle.visible = false;
		//      }, 5000);
		//  }

		if (Ti.App.Properties.getBool('NotNow') && app_loads > 2 && Ti.App.Properties.getBool('reviewRequest', true)) {
			if (app_loads % 3 == 0)
				myApp.global.reviewRequest();
		} else if (pageviews % interstital_ad_pages == 0 && app_loads > 4 && Ti.App.Properties.getBool('video_add', true)) {
			// fullPageVideoAd(adInterstial_url);
		}
	};

	global.reviewRequest = function() {
		if (ads_on != 1) {
			return;
		}
		var w = Titanium.UI.createWindow({
			backgroundColor : "#eee",
			navBarHidden : false,
			orientationModes : [Titanium.UI.PORTRAIT],
			layout : 'vertical',
			theme : "Theme.AppCompat.Fullscreen",
			modal : true
		});

		var title = Ti.UI.createLabel({
			top : padding,
			color : col_title,
			text : L("Are_you_enjoying_this_free_app"),
			height : deviceWidth * (0.05) + padding,
			font : {
				fontSize : deviceWidth * (0.05)
			},
			textAlign : 'center'
		});
		w.add(title);

		var msg = Ti.UI.createLabel({
			top : border,
			text : L("Could_you_help_us_share_the_love_with_a_quick_review"),
			color : col_title,
			textAlign : 'center',
			height : 'auto',
			wordwrap : true
		});
		w.add(msg);

		var gotoMkt = Ti.UI.createButton({
			top : border,
			title : L("Go_to_market"),
			color : col_title,
			left : 0,
			right : 0,
			height : deviceWidth * 0.1
		});
		w.add(gotoMkt);
		gotoMkt.addEventListener('click', function(e) {
			Ti.App.Properties.setBool('reviewRequest', false);
			var marketUrl = (vars.app_link) ? vars.app_link : "http://monk.ee/" + vars.project_title;
			Titanium.Platform.openURL(marketUrl);
			w.close();
		});
		var notNow = Ti.UI.createButton({
			top : border,
			title : L("Not_now"),
			color : col_title,
			left : 0,
			right : 0,
			height : deviceWidth * 0.1
		});
		w.add(notNow);
		notNow.addEventListener('click', function(e) {
			Ti.App.Properties.setBool('reviewRequest', true);
			Ti.App.Properties.setBool('NotNow', false);
			w.close();
		});
		var noThnks = Ti.UI.createButton({
			top : border,
			title : L("No_Thanks"),
			color : col_title,
			left : 0,
			right : 0,
			height : deviceWidth * 0.1
		});
		w.add(noThnks);
		noThnks.addEventListener('click', function(e) {
			Ti.App.Properties.setBool('reviewRequest', false);
			w.close();
		});
		var link = Ti.UI.createLabel({
			top : border,
			text : L("Actually_I_have_a_problem"),
			color : 'blue',
			textAlign : 'center',
			height : 'auto',
			wordwrap : true
		});
		w.add(link);
		link.addEventListener('click', function(e) {
			link.color = '#FFA500';
			Ti.App.Properties.setBool('reviewRequest', false);
			Titanium.Platform.openURL(vars.help_url);
			link.color = 'blue';
			w.close();
		});
		w.orientationModes = [Titanium.UI.PORTRAIT];
		if (fantasticWin.title != 'Home') {
			w.open();
		}
	};

	global.fullPageVideoAd = function(adInterstial_url) {
		if (ads_on == 1) {
			Ti.API.info('browsing to: ' + adInterstial_url);
			var loading = false;
			var w = Titanium.UI.createWindow({
				navBarHidden : false,
				backgroundImage : "custom/master-bg.png",
				orientationModes : [Titanium.UI.PORTRAIT],
				theme : "Theme.AppCompat.Fullscreen",
				modal : true
			});

			var view = Titanium.UI.createWebView({
				top : border + buttonHeight,
				right : border,
				left : border,
				// borderRadius : radius,
				bottom : buttonHeight + border,
				backgroundColor : "#fff",
				url : "/loading.html",
				cacheMode : (is_android) ? Titanium.UI.Android.WEBVIEW_LOAD_NO_CACHE : 0
			});

			view.addEventListener('beforeload', function(e) {
				if (!loading) {
					loading = true;
					//Start Activity Indicator Here
					actInd.show();
					setTimeout(function() {
						if (loading) {
							loading = false;
							//Hide activity indicator here
							actInd.hide();
						}
					}, 3000);
				}
			});

			view.addEventListener('error', function(e) {
				actInd.hide();
				Titanium.API.info(e.message);
				view.url = "/error.html";
			});

			w.add(view);

			if (checkNetwork(true) == true) {//if there's good network connection
				Titanium.API.info("setting webview url to: " + adInterstial_url);
				view.url = adInterstial_url;
				//set the url after it's added
			} else {
				view.url = "/error.html";
			}
			// logIt("fullPageVideoAd", w.url, adInterstial_url);
			backBtn = Titanium.UI.createButton({
				top : padding,
				left : (mainWindowWidth + padding) / 4,
				width : 75 * scaleFactor,
				height : buttonHeight,
				font : {
					fontSize : buttonFontSize,
					fontWeight : 'bold',
					fontFamily : 'Helvetica Neue'
				},
				title : L("Back"),
				enabled : false
			});
			backBtn.addEventListener('click', function() {
				Ti.API.info('going back');
				view.goBack();
			});
			w.add(backBtn);
			fwdBtn = Titanium.UI.createButton({
				top : padding,
				left : backBtn.width + backBtn.left + 30,
				width : 75 * scaleFactor,
				height : buttonHeight,
				font : {
					fontSize : buttonFontSize,
					fontWeight : 'bold',
					fontFamily : 'Helvetica Neue'
				},
				title : L("Forward"),
				enabled : false
			});
			fwdBtn.addEventListener('click', function() {
				Ti.API.info('going forward');
				view.goForward();
			});
			w.add(fwdBtn);

			var breakoutBtn = Titanium.UI.createImageView({
				top : padding,
				left : border,
				width : buttonHeight,
				height : buttonHeight,
				image : "/images/new_window.png"
			});
			breakoutBtn.addEventListener('click', function() {
				Ti.API.info('opening link with system browser: ' + view.url);
				// logIt("breakout", "browser", view.url);
				Titanium.Platform.openURL(view.url);
			});
			w.add(breakoutBtn);

			view.addEventListener('load', function(e) {
				webWindowNavButtons(view, fwdBtn, backBtn);
				actInd.hide();
			});
			var skipBtn = Titanium.UI.createButton({
				title : L("Skip_Advertisement"),
				bottom : padding,
				left : border,
				right : border,
				height : deviceWidth * 0.1,
				color : col_title,
				font : {
					fontSize : buttonFontSize,
					fontWeight : 'bold',
					fontFamily : 'Helvetica Neue'
				},
			});
			skipBtn.addEventListener('click', function() {
				w.close();
			});
			w.add(skipBtn);
			// w.add(actInd);
			w.orientationModes = [Titanium.UI.PORTRAIT];
			if (fantasticWin != 'Home') {
				w.open({
					model : true
				});
			}
		}
	};

	global.adFreePopup = function() {
		if (ads_on == 1) {
			var w = Titanium.UI.createWindow({
				backgroundColor : "#eee",
				navBarHidden : false,
				left : padding,
				right : padding,
				orientationModes : [Titanium.UI.PORTRAIT],
				layout : 'vertical',
				theme : "Theme.AppCompat.Fullscreen",
				modal : true
			});

			var title = Ti.UI.createLabel({
				top : padding,
				color : col_title,
				text : L("Wow_you_awesome"),
				font : {
					fontSize : deviceWidth * (0.07)
				},
				textAlign : 'center',
				height : 'auto',
				wordwrap : true
			});
			w.add(title);

			var msg1 = Ti.UI.createLabel({
				top : border,
				text : L("We_couldnt_help_but_notice_you_seem_to_be_using_this_app_pretty_regularly"),
				color : col_title,
				left : padding,
				right : padding,
				height : 'auto',
				wordwrap : true
			});
			w.add(msg1);

			var msg2 = Ti.UI.createLabel({
				top : border,
				text : L("Would_you_like_to_turn_the_banners_off"),
				color : col_title,
				left : padding,
				right : padding,
				height : 'auto',
				wordwrap : true
			});
			w.add(msg2);

			var msg3 = Ti.UI.createLabel({
				top : border,
				text : L("tell_your_friends_on_Facebook_about_this_app"),
				color : col_title,
				left : padding,
				right : padding,
				height : 'auto',
				wordwrap : true
			});
			w.add(msg3);

			var ok = Ti.UI.createButton({
				top : border,
				title : L("OK_that_sounds_fair"),
				color : col_title,
				left : 0,
				right : 0,
				height : deviceWidth * 0.1
			});
			w.add(ok);
			ok.addEventListener('click', function(e) {
				shareOnFB();
			});
			var notNow = Ti.UI.createButton({
				top : border,
				title : L("Not_now"),
				color : col_title,
				left : 0,
				right : 0,
				height : deviceWidth * 0.1
			});
			w.add(notNow);
			notNow.addEventListener('click', function(e) {
				Ti.App.Properties.setBool('adFreePopup', true);
				w.close();
			});
			var noThnks = Ti.UI.createButton({
				top : border,
				title : L("No_Thanks"),
				color : col_title,
				left : 0,
				right : 0,
				height : deviceWidth * 0.1
			});
			w.add(noThnks);
			noThnks.addEventListener('click', function(e) {
				Ti.App.Properties.setBool('adFreePopup', false);
				w.close();
			});
			w.orientationModes = [Titanium.UI.PORTRAIT];
			if (fantasticWin != 'Home') {
				w.open();
			}
		}
	};

	global.countObject = function(o) {
		var key,
		    count = 0;
		for (key in o) {
			count++;
		}
		return count;
	};

	currentDate = new Date();
	currentTime = currentDate.getTime();
	dayOfWeek = new Date().getDay();

	global.checkHours = function(hours) {
		//need this as well as the above definition, because this fucntion is sometimes called in a different context by update.javascript
		var currentDate = new Date();
		var currentTime = currentDate.getTime();
		var dayOfWeek = new Date().getDay();

		Ti.API.info("checking opening hours: " + hours);

		var todayHours = hours[dayOfWeek];
		var todayOpen = new Date(currentDate.toDateString() + " " + todayHours[0]).getTime();
		var todayClose = new Date(currentDate.toDateString() + " " + todayHours[1]).getTime();

		Ti.API.info("today's hours: " + todayOpen + " to " + todayClose);

		var isOpen = true;

		if (todayClose >= todayOpen) {
			// Open during the day
			isOpen = currentTime >= todayOpen && currentTime < todayClose;
		} else {
			// Open across midnight
			isOpen = currentTime >= todayOpen || currentTime < todayClose;
		}

		Ti.API.info("Is Open?:" + isOpen);
		return isOpen;
	};

	global.findButtonByIndex = function(w, id) {
		Ti.API.info("looking for " + id + " in " + w);
		//  Ti.API.info("num children "+w.children.length);
		for (var x in w.children ) {
			//      Ti.API.info("child: "+w.children[x]);
			if (w.children[x].children[0]) {
				grandchild = w.children[x].children[0];
				//          Ti.API.info("grandchild: "+grandchild);
				if ((grandchild.toString() === "[object TiUIImageView]" || grandchild.toString() === "[object ImageView]") && grandchild.myindex.toString() != "undefined") {
					//              Ti.API.info("index: " + grandchild + " - " + grandchild.myindex);
					if (grandchild.myindex == id) {
						Ti.API.info("found button - returning: ");
						Ti.API.info(grandchild);
						return grandchild;
					}

				}
			}
		}
		return null;
	};

	global.findButtonContainerByIndex = function(w, id) {
		Ti.API.info("looking for " + id + " in " + w);
		// Ti.API.info("num children "+w.children.length);
		for (var x in w.children ) {
			var child = w.children[x];
			// Ti.API.info("child: "+child);
			if (child.myContainerIndex && child.myContainerIndex.toString() != "undefined") {
				// Ti.API.info("index: " + child + " - " + child.myContainerIndex);
				if (child.myContainerIndex == id) {
					Ti.API.info("found button - returning: ");
					Ti.API.info(child);
					return child;
				}

			}
		}
		return null;
	};

	function hexToRgb(hex) {
		// Expand shorthand form (e.g. "03F") to full form (e.g. "0033FF")
		var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;
		hex = hex.replace(shorthandRegex, function(m, r, g, b) {
			return r + r + g + g + b + b;
		});

		var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
		return result ? {
			r : parseInt(result[1], 16),
			g : parseInt(result[2], 16),
			b : parseInt(result[3], 16)
		} : null;
	};

	function decToHex(dec) {
		var number = Math.floor(dec * 255);
		var hex = (number + 0x10000).toString(16).substr(-2).toUpperCase();
		return hex;
	};

	global.createBackgroundImage = function() {
		var bgImg = Ti.UI.createView({
			top : 0,
			width : '100%',
			height : is_android ? '100%' : deviceHeight - adWindowHeight * 1.25,
			bottom : is_android ? 0 : adWindowHeight * 1.25,
		});
		var bgImgView = Ti.UI.createImageView({
			top : 0,
			// image : resDir + 'custom/100136798-251346-background.jpg',
			image : moduleBgImg,
			width : '100%',
			height : '100%',
		});
		bgImg.add(bgImgView);

		return bgImg;
	};

	global.removeChildren = function(obj) {
		if (obj) {
			try {
				obj.visible = false;
				for (i in obj.children) {
					var child = obj.children[0];
					global.removeChildren(child);
					obj.remove(child);
					child = null;
				}
				obj.visible = true;
			} catch(e) {
				Ti.API.info('error ' + e);
			}
		}
	};

	myApp.global = global;
})();
