//new SIDE PANEL menu
Ti.API.info("doing THUMB layout");

var vScaleFactor = Titanium.Platform.displayCaps.platformHeight / 480;
var hidden_top = 300 * scaleFactor;
var shown_top = 0;
//default menu goes all the way up...

// change some variables depending on what type of window it is...
if (is_home === false) {//if it's on a module window
	//?
} else {//if it's on the home window
	if (vars.show_title != "false" && vars.show_title != "none") {//there IS a header
		shown_top = 50 * scaleFactor;
		//put it at the bottom
	} else {

	}
}

var iconBtnSize = 30 * vScaleFactor;
if (Titanium.Platform.displayCaps.platformWidth >= 500) {
	var iconText = 8 * scaleFactor;
} else {
	var iconText = 10 * scaleFactor;
}

var menuViewWidth = (160 * scaleFactor);
var menuView = Ti.UI.createView({
	width : menuViewWidth,
	bottom : 50 * scaleFactor,
	top : hidden_top,
	right : -menuViewWidth,
	zIndex : 9999,
	// backgroundColor : (col_back == undefined) ? 'white' : col_back,
	backgroundColor : "transparent",
	my_id : Math.random()
	// opacity: 0
});

//used to detect clicks OFF the menu
var mask = Ti.UI.createView({
	width : Titanium.Platform.displayCaps.platformWidth,
	bottom : 0,
	top : 0,
	right : -Titanium.Platform.displayCaps.platformWidth,
	zIndex : 9997,
	backgroundColor : "white",
	opacity : 0.05
});
mask.addEventListener('click', function(e) {
	Ti.API.info('mask clicked');
	menuView_toggle();
	return false;
});

// Menu Titles
var tableData = [];

for (var p in pages) {//have to check each page for each position
	if (pages[p].on === true) {//if it's on, and the order matches the current position
		Ti.API.info(pages[p].name);

		var row = Ti.UI.createTableViewRow({
			className : 'panelMenu',
			backgroundColor : "transparent",
			myindex : p, // custom property, used for opening the module on click
			rowOrder : pages[p].order,
			height : 50 * scaleFactor
		});

		var iconFile = ( typeof pages[p].icon != 'undefined') ? ExtDir + 'custom/' + pages[p].icon : resDir + 'images/default_button.png';
		var file = Titanium.Filesystem.getFile(iconFile);
		if (!file.exists()) {
			iconFile = ( typeof pages[p].icon != 'undefined') ? resDir + 'custom/' + pages[p].icon : resDir + 'images/default_button.png';
			if (!is_android) {
				var iconiImgFile = ( typeof pages[p].icon != 'undefined') ? 'custom/' + pages[p].icon : 'images/default_button.png';
			}
		}
		var file = Titanium.Filesystem.getFile(iconFile);
		if (!file.exists()) {
			iconFile = 'https://origin-files.infinitemonkeys.mobi/userfiles/' + pages[p].icon;
		} else {
			if (!is_android && !myApp.autoUpdated) {
				iconFile = iconiImgFile;
			}
		}

		// Ti.API.info("iconfile: " + iconFile);
		var imgBtn = Titanium.UI.createImageView({
			image : iconFile,
			height : iconBtnSize,
			width : iconBtnSize,
			right : 10 * scaleFactor
		});
		row.add(imgBtn);

		var titleText = Titanium.UI.createLabel({
			text : pages[p].title,
			font : {
				fontSize : iconText,
				fontWeight : "bold"
			},
			textAlign : 'center',
			color : "#333",
			width : Ti.UI.SIZE,
			top : 5,
			right : 5,
			bottom : 5,
			left : 5,
			height : Ti.UI.SIZE
		});

		var wrapper = Ti.UI.createView({
			right : 55 * scaleFactor,
			width : Ti.UI.SIZE,
			height : Ti.UI.SIZE,
			backgroundColor : "#ddd",
			borderRadius : 7,
			borderColor : "#aaa"
		});

		wrapper.add(titleText);
		row.add(wrapper);
		tableData.push(row);
	}
}

//******* ADD SPECIAL ROWS

//HOME row
var row = Ti.UI.createTableViewRow({
	className : 'panelMenu',
	backgroundColor : "transparent",
	click_function : function() {
		if (is_home === false) {
			Ti.API.info("HOME BUTTON closing currentWindow");
			setTimeout(function(e) {
				is_home = true;
				myCurrentWindow.close();
			}, 300);
		}
	},
	height : 50 * scaleFactor,
	rowOrder : 0
});
var titleText = Titanium.UI.createLabel({
	text : "HOME",
	font : {
		fontSize : iconText
	},
	textAlign : 'center',
	color : "#333",
	width : Ti.UI.SIZE,
	top : 5,
	right : 5,
	bottom : 5,
	left : 5,
	height : Ti.UI.SIZE
});

var wrapper = Ti.UI.createView({
	right : 55 * scaleFactor,
	width : Ti.UI.SIZE,
	height : Ti.UI.SIZE,
	backgroundColor : "#ddd",
	borderRadius : 7,
	borderColor : "#aaa"
});

wrapper.add(titleText);
row.add(wrapper);

var imgBtn = Ti.UI.createLabel({
	text : iconicFont.icon('fa-home'),
	color : "#ddd",
	font : {
		fontSize : iconBtnSize,
		fontFamily : iconicFont.fontfamily
	},
	textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
	verticalAlign : Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
	height : iconBtnSize,
	width : iconBtnSize,
	right : 10 * scaleFactor,
	shadowColor : tableBgColor_semi,
	shadowRadius : 2,
	shadowOffset : {
		x : 1,
		y : 1
	}
});
row.add(imgBtn);
if (is_home === false) {//if it's on a module window
	tableData.push(row);
}

//INFO row
var row = Ti.UI.createTableViewRow({
	className : 'panelMenu',
	backgroundColor : "transparent",
	click_function : function() {
		Ti.API.info("INFO BUTTON CLICKED");
		if (is_home === false) {
			Ti.API.info("more info closing currentWindow");
			is_home = true;
			myCurrentWindow.close();
		}
		doMenuOption("More Info");
	},
	height : 55 * scaleFactor,
	rowOrder : 1000
});
var titleText = Titanium.UI.createLabel({
	text : "More Info",
	font : {
		fontSize : iconText
	},
	textAlign : 'right',
	color : "#333",
	width : Ti.UI.SIZE,
	top : 5,
	right : 5,
	bottom : 5,
	left : 5,
	height : Ti.UI.SIZE
});

var wrapper = Ti.UI.createView({
	right : 55 * scaleFactor,
	width : Ti.UI.SIZE,
	height : Ti.UI.SIZE,
	backgroundColor : "#ddd",
	borderRadius : 7,
	borderColor : "#aaa"
});
wrapper.add(titleText);
row.add(wrapper);

var imgBtn = Ti.UI.createLabel({
	text : iconicFont.icon('fa-info-circle'),
	color : "#ddd",
	font : {
		fontSize : iconBtnSize - 10,
		fontFamily : iconicFont.fontfamily
	},
	textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
	verticalAlign : Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
	height : iconBtnSize,
	width : iconBtnSize,
	right : 10 * scaleFactor,
	shadowColor : tableBgColor_semi,
	shadowRadius : 2,
	shadowOffset : {
		x : 1,
		y : 1
	}
});
row.add(imgBtn);
tableData.push(row);

//SHARE row
var row = Ti.UI.createTableViewRow({
	className : 'panelMenu',
	backgroundColor : "transparent",
	click_function : function() {
		Ti.API.info("SHARE BUTTON CLICKED");
		is_home = true;
		doMenuOption("Send to a Friend");
	},
	height : 55 * scaleFactor,
	rowOrder : 1001
});
var titleText = Titanium.UI.createLabel({
	text : "Share",
	font : {
		fontSize : iconText
	},
	textAlign : 'right',
	color : "#333",
	width : Ti.UI.SIZE,
	top : 5,
	right : 5,
	bottom : 5,
	left : 5,
	height : Ti.UI.SIZE
});

var wrapper = Ti.UI.createView({
	right : 55 * scaleFactor,
	width : Ti.UI.SIZE,
	height : Ti.UI.SIZE,
	backgroundColor : "#ddd",
	borderRadius : 7,
	borderColor : "#aaa"
});
wrapper.add(titleText);
row.add(wrapper);

var imgBtn = Ti.UI.createLabel({
	text : iconicFont.icon('fa-share-alt'),
	color : "#ddd",
	font : {
		fontSize : iconBtnSize - 10,
		fontFamily : iconicFont.fontfamily
	},
	textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
	verticalAlign : Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
	height : iconBtnSize,
	width : iconBtnSize,
	right : 10 * scaleFactor,
	shadowColor : tableBgColor_semi,
	shadowRadius : 2,
	shadowOffset : {
		x : 1,
		y : 1
	}
});
row.add(imgBtn);
tableData.push(row);

//**** Assemble table

tableData.sort(rowOrder);

function rowOrder(b, a) {
	try {
		var y = parseInt(a.rowOrder);
		var x = parseInt(b.rowOrder);
		// Ti.API.info("y : "+ y + " x : "+ x);
		if (y > x)
			return 1;
		else if (y < x)
			return -1;
		else
			return 0;
	} catch(sortErr) {
		Ti.API.info("not sorting: " + sortErr);
		return 1;
	}
}

// Tableview
var tableView = Ti.UI.createTableView({
	data : tableData,
	backgroundColor : "transparent",
	separatorColor : 'transparent'
});

tableView.addEventListener('click', function(e) {
	Ti.API.info("click");
	Ti.API.info(e.rowData);
	var source = e.rowData;
	if (source.myindex) {
		menuView_toggle();
		if (is_home === false) {
			Ti.API.info("closing currentWindow before opening new one...");
			myCurrentWindow.close();
		} else {
			Ti.API.info("no currentwindow to close");
		}
		myApp.menuClick(source.myindex);
	} else if (source.click_function) {
		menuView_toggle();
		source.click_function();
	}
});
tableView.scrollToIndex(tableView.data[0].rows.length - 1);

//*********** SLIDING ACTIONS
var STATUS = {
	OPEN : 0,
	CLOSED : 1,
	ANIMATING : 2
};
var ANIMATION_DURATION = 300;
var status = STATUS.CLOSED;
var tapCatcher = null;

// menuView.toggle = function() {
var menuView_toggle = function() {
	Ti.API.debug("myApp.menuView: ");
	Ti.API.debug(myApp.menuView);
	Ti.API.debug(myApp.menuView.my_id);
	if (is_home) {
		Ti.API.info("on HOME view, so adjusting menuView var");
		menuView = myApp.menuView;
	}
	Ti.API.debug("menuView: ");
	Ti.API.debug(menuView);

	if (status == STATUS.CLOSED) {
		Ti.API.info('slider.opening');
		status = STATUS.ANIMATING;
		menuView.animate({
			opacity : 1,
			top : shown_top,
			// right : 15*scaleFactor,
			right : padding,
			duration : ANIMATION_DURATION,
			curve : Ti.UI.ANIMATION_CURVE_EASE_IN_OUT
		}, function() {
			menuView.right = padding;
			if (is_home)
				menuView.parent.children[1].right = padding;
			else
				mask.right = 0;
			// menuView.right = 15*scaleFactor;
			status = STATUS.OPEN;
			// slider.fireEvent('open');
			Ti.API.info('slider is OPEN');
		});

	} else if (status == STATUS.OPEN) {
		Ti.API.info('slider.closing');
		if (is_home)
			menuView.parent.children[1].right = -Titanium.Platform.displayCaps.platformWidth;
		else
			mask.right = -Titanium.Platform.displayCaps.platformWidth;
		status = STATUS.ANIMATING;
		menuView.animate({
			top : hidden_top,
			opacity : 0,
			right : -menuViewWidth,
			duration : ANIMATION_DURATION,
			curve : Ti.UI.ANIMATION_CURVE_EASE_IN_OUT
		}, function() {
			menuView.right = -menuViewWidth;
			status = STATUS.CLOSED;
			// slider.fireEvent('close');
			Ti.API.info('slider is CLOSED');
		});

	} else {
		Ti.API.info('slider is already animating');
	}
};

menuView.add(tableView);

//thumb_button MENU BUTTON
var thumb_button_size = 30 * scaleFactor;
var thumb_button = Titanium.UI.createImageView({
	image : resDir + 'images/thumb_plus.png',
	bottom : padding,
	right : padding,
	height : thumb_button_size,
	width : thumb_button_size,
	// color : "green",
	// font : {
	// 	fontSize : thumb_button_size,
	// 	fontFamily : iconicFont.fontfamily
	// },
	// text : iconicFont.icon('fa-plus-circle'),
	// textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
	// verticalAlign : Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
	zIndex : 9998,
	// backgroundColor : "transparent",
	shadowColor : tableBgColor_semi,
	shadowRadius : 2,
	shadowOffset : {
		x : 1,
		y : 1
	},
	my_id : Math.random()
});

thumb_button.addEventListener('click', function(e) {
	Ti.API.info('thumb_button clicked');
	Ti.API.info(e.source.my_id);
	menuView_toggle();
	return false;
});

//WHERE SHOULD WE ADD THESE THINGS...
if (is_home === true) {
	Ti.API.info("adding menu to myApp.container");

	myApp.container.add(mask);
	myApp.container.add(menuView);
	myApp.menuView = menuView;
	myApp.container.add(thumb_button);
} else {
	Ti.API.info("adding menu to myCurrentWindow");
	myCurrentWindow.add(mask);
	myCurrentWindow.add(menuView);
	myCurrentWindow.add(thumb_button);
	if (is_android) {
		myCurrentWindow.addEventListener("android:back", function(e) {
			Ti.API.info("android back click");
			is_home = true;
			myCurrentWindow.close();
			myCurrentWindow = null;
		});
	}
}
