//********* ADDED TO REPLACE DEPRECATED TITANIUM.INCLUDE function
Titanium.include = function(file) {(1,eval)(Ti.Filesystem.getFile(Ti.Filesystem.resourcesDirectory, file).read().text);}
//*********

Titanium.include('/functions/functions.javascript');
Titanium.include('/functions/functions_format.javascript');

function createPrivateChatRoom(chatData, bgFile, myindex) {
	var chatTV;
	var alertTitleMailId;
	var openOptionDialog = false;
	var receverUserData = {};
	var firstTime = false;

	var containerWin = Ti.UI.createWindow({
		//title : "Private Chat",
		theme : "Theme.AppCompat.Fullscreen",
		bgImage : bgFile,
		pageIndex : myindex,
		navBarHidden : true,
		tabBarHidden : true,
		fullscreen : true,
		backgroundColor : '#000',
		//top : 0,
		//height : mainWindowHeight,
		zIndex : 1,
		orientationModes : [Titanium.UI.PORTRAIT]
	});
	containerWin.add(myApp.global.createBackgroundImage());
	myApp.global.addPageTitle("Private Chat", 99, containerWin);

	var titleLabel = Ti.UI.createLabel({
		text : L('Private Chat'),
		top : (is_android) ? padding : padding * 3,
		height : Titanium.UI.SIZE,
		textAlign : 'center',
		font : {
			fontWeight : 'bold',
			fontSize : titleSize
		},
		color : col_title
	});
	//containerWin.add(titleLabel);

	// var backButton = Titanium.UI.createButton({
	// title : ' ' + L('Back') + ' ',
	// top : (is_android) ? padding : padding * 3,
	// left : rowMargin,
	// height : buttonHeight,
	// zIndex : 99,
	// backgroundColor : col_title,
	// color : col_back,
	// borderRadius : padding * 0.5,
	// font : {
	// fontSize : buttonFontSize,
	// fontWeight : 'bold',
	// //		fontFamily : 'Helvetica Neue'
	// },
	// });
	var backButton = Ti.UI.createButton({
		left : 0,
		width : homeButtonSize,
		height : homeButtonSize,
		top : (is_android) ? padding : padding * 3,
		color : col_title,
		font : {
			fontSize : titleSize,
			fontFamily : iconicFont.fontfamily
		},
		title : iconicFont.icon('fa-arrow-left'),
		textAlign : Ti.UI.TEXT_ALIGNMENT_CENTER,
		verticalAlign : Ti.UI.TEXT_VERTICAL_ALIGNMENT_CENTER,
		backgroundColor : 'transparant',
	});
	if (is_android) {
		backButton.left = padding;
	} else {
		//backButton.right = padding;
		backButton.height = 32;
	}
	containerWin.add(backButton);
	backButton.addEventListener('click', function(e) {
		Ti.App.fireEvent("disconnect_socket");
		var module = require('/mymodules/chat/chat').moduleWindow;
		//Create new instance
		var newWin = new module(bgFile, myindex);
		newWin.open();
		removListenPC();
		containerWin.close();
		chatTV.removeAllChildren();
		myApp.global.removeChildren(containerWin);
		containerWin = null;
	});

	var container = Ti.UI.createView({
		top : homeButtonSize,
		bottom : adWindowHeight + padding,
		left : 0,
		width : '100%',
		height : '100%',
		touchEnabled : true,
		backgroundColor : 'red',
		layout : 'vertical',
		zIndex : 99,
	});

	var style;
	if (Ti.Platform.name === 'iPhone OS') {
		style = Titanium.UI.iOS.ActivityIndicatorStyle.PLAIN;
	} else {
		style = Ti.UI.ActivityIndicatorStyle.DARK;
	}

	var activityIndicator = Ti.UI.createActivityIndicator({
		color : col_title,
		font : {
			fontFamily : 'Helvetica Neue',
			fontSize : '16dp',
			fontWeight : 'bold'
		},
		message : 'Loading...',
		style : style,
		height : Ti.UI.SIZE,
		width : Ti.UI.SIZE,
		zIndex : 100,
	});

	// The activity indicator must be added to a window or view for it to appear
	containerWin.add(activityIndicator);

	var webview = Ti.UI.createWebView({
		url : '/private_webview.html',
		top : 0,
		left : 0,
		visible : false,
	});
	containerWin.add(webview);
	// containerWin.add(container);
	var otherDevID;
	if (uuid != chatData.to)
		otherDevID = chatData.to;
	else if (uuid != chatData.from)
		otherDevID = chatData.from;

	/*
	 * Create a node room based on appId fired when socket connected.
	 */
	var my_nickname = Ti.App.Properties.getString('chat_name');
	var my_email = Ti.App.Properties.getString('chat_address');
	Ti.App.addEventListener('private_chat_connected', privateChatConnected);
	var isConnect = true;

	function privateChatConnected() {
		Ti.API.info("private chat connected...");

		if (isConnect) {
			isConnect = false;
			// if (my_nickname && my_email) {
			Ti.API.info("Chat Data : " + JSON.stringify(chatData));
			openChatWindow(my_nickname, my_email);
			Ti.API.info('private_chat_connected:chat');

			Ti.App.fireEvent('create_private_node_room', {
				app_id : vars.app_id,
				me_deviceId : uuid,
				timeZone : '',
				room_id : chatData.private_room_id,
				other_deviceId : otherDevID
			});

			//firstTime = true;
			//Ti.API.info("private chat connected .... : "+ firstTime);

			// } else {
			// containerWin.add(container);
			// }
			activityIndicator.hide();
		}
	}

	function openChatWindow(userName, email) {

		var chatContainer;
		if (is_android) {
			chatContainer = Ti.UI.createView({
				top : homeButtonSize,
				bottom : adWindowHeight,
				left : 0,
				width : '100%',
				touchEnabled : true,
				backgroundColor : 'transparent',
				zIndex : 99,
			});
		} else {
			chatContainer = Ti.UI.createScrollView({
				top : homeButtonSize + padding,
				bottom : adWindowHeight,
				left : 0,
				width : '100%',
				touchEnabled : true,
				backgroundColor : 'transparent',
				zIndex : 99,
			});
		}

		chatTV = Ti.UI.createScrollView({
			top : 0,
			left : 0,
			bottom : homeButtonSize + padding,
			right : 0,
			backgroundColor : 'transparent',
			width : '100%',
			layout : 'vertical',
			scrollType : 'vertical'
		});
		chatContainer.add(chatTV);
		var viewTF = Ti.UI.createView({
			bottom : 0,
			left : 0,
			width : '100%',
			height : homeButtonSize,
			touchEnabled : true,
			backgroundColor : col_back,
			layout : 'horizontal',
			opacity : 0.7
		});
		chatContainer.add(viewTF);

		var chatBoxTF = Ti.UI.createTextField({
			bottom : 0,
			width : '75%',
			left : padding,
			height : homeButtonSize - 5,
			hintText : L("New_Message"),
			hintTextColor : "#CDCDCD",
			opacity : 0.6,
			color : col_title,
			backgroundColor : 'transparent',
			returnKeyType : Titanium.UI.RETURNKEY_DONE
		});
		viewTF.add(chatBoxTF);

		chatBoxTF.addEventListener('return', function(e) {
			if (chatBoxTF.value == '') {
				// chatBoxTF.value = ' ';
				// chatBoxTF.hintText = 'You must enter message';
			}
			if (chatBoxTF.value != null && chatBoxTF.value != 'undefined' && chatBoxTF.value != '') {
				var tokenEncoded = Ti.Utils.base64encode((chatBoxTF.value).trim());
				tokenEncoded = tokenEncoded.toString();
				tokenEncoded = tokenEncoded.replace(/\n/g, '');
				tokenEncoded = tokenEncoded.replace(/\r/g, '');

				Ti.API.info('tokenEncoded  ' + tokenEncoded);
				Ti.App.fireEvent('broadcast_private_Chat', {
					msg : tokenEncoded,
					appId : vars.app_id,
					deviceId : uuid,
					userName : userName,
					isGroupChat : 0,
					to_id : otherDevID
				});
				var date = new Date();
				var dateLabel = date.format("mmm d, HH:MM");

				// addRow(chatBoxTF.value, userName, dateLabel, Ti.App.Properties.getString('chat_address'), true);
				chatBoxTF.value = '';
			}
		});
		
		/*send button removed, now keyoboard Return function is used to send data (26 sep 2016 by Ashish).*/
		// var sendBtn = Ti.UI.createButton({
			// title : L('Send'),
			// backgroundColor : 'transparent',
			// left : 4,
			// height : homeButtonSize - 5,
			// width : '20%',
			// color : titleColor
		// });
		//viewTF.add(sendBtn);

		// sendBtn.addEventListener('click', function(e) {
		// if (chatBoxTF.value == '') {
		// // chatBoxTF.value = ' ';
		// // chatBoxTF.hintText = 'You must enter message';
		// }
		// if (chatBoxTF.value != null && chatBoxTF.value != 'undefined' && chatBoxTF.value != '') {
		// var tokenEncoded = Ti.Utils.base64encode((chatBoxTF.value).trim());
		// tokenEncoded = tokenEncoded.toString();
		// tokenEncoded = tokenEncoded.replace(/\n/g, '');
		// tokenEncoded = tokenEncoded.replace(/\r/g, '');
		//
		// Ti.API.info('tokenEncoded  ' + tokenEncoded);
		// Ti.App.fireEvent('broadcast_private_Chat', {
		// msg : tokenEncoded,
		// appId : vars.app_id,
		// deviceId : uuid,
		// userName : userName,
		// isGroupChat : 0,
		// to_id : otherDevID
		// });
		// var date = new Date();
		// var dateLabel = date.format("mmm d, HH:MM");
		//
		// // addRow(chatBoxTF.value, userName, dateLabel, Ti.App.Properties.getString('chat_address'), true);
		// chatBoxTF.value = '';
		// }
		// });

		containerWin.add(chatContainer);
	}

	removListenPC = function(e) {
		Ti.API.info("remove Listener ... private Chat");
		//Ti.App.removeEventListener('get_user_status', userCurStatCalBak);

		Ti.App.removeEventListener('got_history_data', setBrodMsgPCCalBak);
		Ti.App.removeEventListener('got_chat_request', gotChatReqCalBak);
		Ti.App.removeEventListener('deny_chat_req', denyChatReqCalBak);
		Ti.App.removeEventListener('private_chat_connected', privateChatConnected);
		Ti.App.removeEventListener('private_chat_offline', userOfflineCalBak);

		//Ti.App.removeEventListener('got_start_chat', strtChatCalBak);
	};

	var gotChatReqCalBak = function(e) {
		var dataArr = JSON.parse(JSON.stringify(e.data));
		Ti.API.info("User Status : " + dataArr.data.msg);
		if (dataArr.data.check == 1)
			createDialog(dataArr.data, "Chat Request");
	};

	Ti.App.addEventListener('got_chat_request', gotChatReqCalBak);

	var denyChatReqCalBak = function(e) {
		var dataArr = JSON.parse(JSON.stringify(e));
		//Ti.API.info("NOTIFY Status : " + JSON.stringify(dataArr));
		var dialog = Ti.UI.createAlertDialog({
			title : " ",
			message : e.data.username + "has denied your request.",
		});
		dialog.show();

	};

	Ti.App.addEventListener('deny_chat_req', denyChatReqCalBak);

	/*
	 var userCurStatCalBak = function(e) {
	 var dataArr = JSON.parse(JSON.stringify(e.data));
	 Ti.API.info("user_current_status : " + dataArr.data.activeUser);

	 if (dataArr.data.activeUser == 1 && openOptionDialog) {
	 receverUserData = dataArr;
	 optionDial.show();
	 }

	 };

	 Ti.App.addEventListener('get_user_status', userCurStatCalBak);*/

	var setBrodMsgPCCalBak = function(e) {
		var dataArr = JSON.parse(JSON.stringify(e.data));
		dataArr = dataArr.data;
		Ti.API.info('fired -> got_history_data ' + dataArr.type);
		if (dataArr.type == "history") {

			try {
				activityIndicator.show();
				if (chatTV) {
					chatTV.visible = false;
					chatTV.removeAllChildren();
				}

				Ti.API.info("get length : " + dataArr.data.length);

				for (var i = 0; i < dataArr.data.length; i++) {
					Ti.API.info('fired -> data  history ' + dataArr.data[i]);
					dateLabel = getLocalTime(new Date(dataArr.data[i].time));
					if (dataArr.data[i].deviceId == uuid) {
						addRow(Ti.Utils.base64decode(dataArr.data[i].message), dataArr.data[i].userName, dateLabel, dataArr.data[i].email, dataArr.data[i].deviceId, true, dataArr.data[i].is_active);
					} else {
						addRow(Ti.Utils.base64decode(dataArr.data[i].message), dataArr.data[i].userName, dateLabel, dataArr.data[i].email, dataArr.data[i].deviceId, false, dataArr.data[i].is_active);
					}
				}
			} catch(e) {
				Ti.API.info('Error ' + e);
			}
			activityIndicator.hide();
			chatTV.visible = true;

		} else if (dataArr.type == "chat_message") {
			dateLabel = getLocalTime(new Date(dataArr.data.time));
			if (dataArr.data.deviceId == uuid) {
				addRow(Ti.Utils.base64decode(dataArr.data.message), dataArr.data.userName, dateLabel, dataArr.data.email, dataArr.data.deviceId, true, "online");
			} else {
				addRow(Ti.Utils.base64decode(dataArr.data.message), dataArr.data.userName, dateLabel, dataArr.data.email, dataArr.data.deviceId, false, "online");
			}
			// addRow(Ti.Utils.base64decode(dataArr.data.message), dataArr.data.userName, dateLabel, dataArr.data.email, true);
		}
	};

	Ti.App.addEventListener('got_history_data', setBrodMsgPCCalBak);

	var setBrodMsgCalBak = function(e) {
		var dataArr = JSON.parse(JSON.stringify(e.data));
		dataArr = dataArr.data;

		Ti.API.info('fired -> set_message_privateChat isGrpChat' + dataArr.data.isGroupChat);

		if (dataArr.isGroupChat == 1)
			return;

		Ti.API.info('fired -> set_message_privateChat ' + dataArr.type);
		if (dataArr.type == "history") {

			try {
				activityIndicator.show();
				if (chatTV) {
					chatTV.visible = false;
					chatTV.removeAllChildren();
				}

				for (var i = 0; i < dataArr.data.length; i++) {
					Ti.API.info('fired -> data  history ' + dataArr.data[i].message);
					dateLabel = getLocalTime(new Date(dataArr.data[i].time));
					if (dataArr.data[i].deviceId == uuid) {
						addRow(Ti.Utils.base64decode(dataArr.data[i].message), dataArr.data[i].userName, dateLabel, dataArr.data[i].email, dataArr.data[i].deviceId, true, dataArr.data[i].is_active);
					} else {
						addRow(Ti.Utils.base64decode(dataArr.data[i].message), dataArr.data[i].userName, dateLabel, dataArr.data[i].email, dataArr.data[i].deviceId, false, dataArr.data[i].is_active);
					}
				}
			} catch(e) {
				Ti.API.info('Error ' + e);
			}
			activityIndicator.hide();
			chatTV.visible = true;

		} else if (dataArr.type == "chat_message") {
			dateLabel = getLocalTime(new Date(dataArr.data.time));
			if (dataArr.data.deviceId == uuid) {
				addRow(Ti.Utils.base64decode(dataArr.data.message), dataArr.data.userName, dateLabel, dataArr.data.email, dataArr.data.deviceId, true, "online");
			} else {
				addRow(Ti.Utils.base64decode(dataArr.data.message), dataArr.data.userName, dateLabel, dataArr.data.email, dataArr.data.deviceId, false, "online");
			}
			// addRow(Ti.Utils.base64decode(dataArr.data.message), dataArr.data.userName, dateLabel, dataArr.data.email, true);
		}
	};

	Ti.App.addEventListener('set_message_privateChat', setBrodMsgCalBak);

	var userOfflineCalBak = function(e) {
		var dataArr = JSON.parse(JSON.stringify(e.data));
		dataArr = dataArr.data;

		Ti.API.info('fired -> after_user_offline ' + dataArr);

		fetchUserName(dataArr);

	};

	Ti.App.addEventListener('private_chat_offline', userOfflineCalBak);

	/*
	 var strtChatCalBak = function(e) {
	 var dataArr = JSON.parse(JSON.stringify(e.data));
	 dataArr = dataArr.conversation;
	 Ti.API.info('fired -> got_start_chat ' + dataArr);
	 if (dataArr.check == 1)
	 openPrivateWin(dataArr);
	 else if (dataArr.check == 2)
	 Ti.API.info('Video Chat');
	 };

	 Ti.App.addEventListener('got_start_chat', strtChatCalBak);*/

	/*
	 function createDialog(data, titleMsg) {
	 Ti.API.info("Create Dialog" + data.msg);
	 var dialog = Ti.UI.createAlertDialog({
	 title : titleMsg,
	 message : data.msg,
	 buttonNames : ['Accept', 'Deny'],
	 });
	 dialog.show();
	 dialog.addEventListener('click', function(e) {
	 if (e.index == 0) {
	 Ti.API.info("Hit Accept");

	 Ti.App.fireEvent('subscribe', {
	 fromID : data.from,
	 toID : data.to,
	 private_room_id : "Private_Room_User1_" + data.from + "User2_" + data.to,
	 checkVal : data.check
	 });
	 } else if (e.index == 1) {
	 Ti.API.info("Hit Deny");
	 Ti.App.fireEvent('deny_chat_request', {
	 from : data.to,
	 toName : Ti.App.Properties.getString('chat_name'),
	 });
	 }
	 dialog.hide();
	 });
	 }*/

	function addRow(message, userName, date_val, email, device_ID, config, is_Active) {
		Ti.API.info("userName + " + userName);

		var email = ((email).trim()).toLowerCase();
		var md_data = Titanium.Utils.md5HexDigest(email);
		var gravatarUrl = "http://www.gravatar.com/avatar/" + md_data + "?s=100&r=g&d=404";

		if (!Ti.App.Properties.getString(userName)) {
			Ti.App.Properties.setString(userName, getRandomColor());
		}
		if (config) {
			left_val = deviceWidth / 4.5;
			right_val = 0;
			card_color = col_back;
			card_opacity = 1;
		} else {
			left_val = 0;
			right_val = deviceWidth / 4.5;
			card_color = col_back;
			card_opacity = 1;
		}

		var row = Ti.UI.createView({
			backgroundColor : "transparent",
			height : Titanium.UI.SIZE,
			//touchEnabled : false,
		});
		var cardViewBack = Ti.UI.createView({
			top : padding,
			left : left_val,
			right : right_val,
			height : Ti.UI.SIZE,
			width : (deviceWidth - left_val) - right_val,
			borderRadius : padding / 2,
			backgroundColor : card_color,
			opacity : card_opacity
		});
		row.add(cardViewBack);
		Ti.API.info('gravatarUrl  ' + gravatarUrl);

		var gravataContainer = Ti.UI.createView({
			height : imageSize / 1.4,
			width : imageSize / 1.4,
			backgroundColor : "transparent",
			mailID : email,
			deviceID : device_ID,
			isActive : is_Active,
			userName : userName,
		});

		var cardImgView = Ti.UI.createImageView({
			image : gravatarUrl,
			color : '#000',
			height : imageSize / 1.4,
			width : imageSize / 1.4,
			borderRadius : (imageSize / 1.4) / 2,
			borderColor : "#777777",
			backgroundColor : Ti.App.Properties.getString(userName),
		});
		gravataContainer.add(cardImgView);

		var lblFL = Ti.UI.createLabel({
			// left : cardImgView.width / 3,
			height : Titanium.UI.SIZE,
			textAlign : 'center',
			text : userName.charAt(0).toUpperCase(),
			font : {
				fontWeight : 'bold',
				fontSize : descSize * 2
			},
			color : '#000',
			touchEnabled : false,
			focusable : false,
		});
		gravataContainer.add(lblFL);

		// Ti.API.info('Active State : ' + is_Active);
		// var onOffIndicator = Ti.UI.createView({
		// height : imageSize / 4,
		// width : imageSize / 4,
		// borderRadius : (imageSize / 4) / 2,
		// backgroundColor : (is_Active == "online") ? "green" : "gray",
		// bottom : 0,
		// right : 0,
		// //zIndex : 99,
		// });
		// gravataContainer.add(onOffIndicator);

		var cardView = Ti.UI.createView({
			top : padding,
			height : Ti.UI.SIZE,
			width : deviceWidth - (left_val + right_val + cardImgView.width),
			borderRadius : padding / 2,
			backgroundColor : card_color,
			layout : 'vertical',
			opacity : card_opacity
		});
		cardViewBack.add(cardView);

		var cardTopView = Ti.UI.createView({
			left : 0,
			right : 0,
			height : Ti.UI.SIZE,
			width : cardView.width,
			// layout : 'horizontal',
		});
		cardView.add(cardTopView);

		var cardBottomView = Ti.UI.createView({
			left : 0,
			right : 0,
			height : Ti.UI.SIZE,
			width : cardView.width,
		});
		cardView.add(cardBottomView);

		var nameLbl = Ti.UI.createLabel({
			top : 0,
			height : Titanium.UI.SIZE,
			textAlign : 'left',
			text : userName,
			font : {
				fontWeight : 'normal',
				fontSize : descSize
			},
			color : col_title
		});

		var msgLbl = Ti.UI.createLabel({
			top : 0,
			bottom : padding,
			height : Titanium.UI.SIZE,
			textAlign : 'left',
			text : message,
			font : {
				fontWeight : 'normal',
				fontSize : titleSize
			},
			color : descColor
		});

		cardBottomView.add(msgLbl);

		cardTopView.add(nameLbl);
		cardViewBack.add(gravataContainer);
		// adjust the GUI possition
		if (config) {
			lblFL.right = cardImgView.width / 4, nameLbl.text = date_val + '      ' + userName;
			nameLbl.left = rowMargin;
			//cardImgView.right = 0;
			gravataContainer.right = padding;
			cardView.right = cardImgView.width;
			msgLbl.left = rowMargin;
		} else {
			lblFL.left = cardImgView.width / 3, nameLbl.text = userName + '    ' + date_val;
			nameLbl.right = rowMargin;
			//cardImgView.left = 0;
			gravataContainer.left = padding;
			cardView.left = cardImgView.width;
			msgLbl.left = rowMargin;
		}

		chatTV.add(row);
		chatTV.scrollToBottom();
	}

	/*
	var optionDial = Ti.UI.createOptionDialog({
	options : [L('text_chat'), L('video_chat'), L('Cancel')],
	//title : 'What would you like to do ?',
	title : alertTitleMailId,
	selectedIndex : -1,
	});

	optionDial.addEventListener('click', function(e) {
	Ti.API.info("Option Selected : " + e.index);
	Ti.API.info("get_user_state Data : " + JSON.stringify(receverUserData));

	if (e.index == 2)
	return;

	if (e.index == 0) {
	Ti.App.fireEvent('check_active_user', {
	app_id : vars.app_id,
	chk_user : receverUserData.data.to,
	meVal : uuid,
	chk_userName : Ti.App.Properties.getString('chat_name'),
	email : receverUserData.data.Email,
	checkVal : 1
	});
	alert('Invitation Sent : Waiting for ' + receverUserData.data.check_username + ' to respond');

	} else if (e.index == 1) {
	Ti.API.info("User Selected Video Chat");

	Ti.App.fireEvent('check_active_user', {
	app_id : vars.app_id,
	chk_user : receverUserData.data.to,
	meVal : uuid,
	chk_userName : receverUserData.data.check_username,
	email : receverUserData.data.Email,
	checkVal : 2
	});

	}
	});*/

	// create a function to return randomly color code value
	function getRandomColor() {
		var letters = '0123456789ABCDEF'.split('');
		var color = '#';
		for (var i = 0; i < 6; i++) {
			color += letters[Math.floor(Math.random() * 16)];
		}
		return color;
	}

	function fetchUserName(deviceID) {
		activityIndicator.show();
		var url = 'https://utils.infinitemonkeys.mobi/chatserver/action.php?action=fetch_UserName';
		Ti.API.info('------url  ' + url);
		var xhr = Titanium.Network.createHTTPClient();
		xhr.onerror = function(e) {
			activityIndicator.hide();
			if (this.status == 0) {
				myApp.global.shoutOut(L("Network_Problem"), L("Either_no_connection_found_or_server_did_not_respond_within_allowed_time"));
			} else {
				myApp.global.shoutOut(L('Operation_Fail'), L('Communication_Error'));
			}
		};
		xhr.setTimeout(10000);
		xhr.onload = function(e) {
			Ti.API.info('Fetch_UserName response  ' + this.responseText);
			var userNameData = JSON.parse(this.responseText);
			try {
				if (userNameData != null) {
					Ti.API.info('userNameData : ' + userNameData);
					var dialog = Ti.UI.createAlertDialog({
						title : "User Offline",
						message : userNameData.Username + " has gone offline.",
						ok : 'Ok'
					});
					dialog.show();
					activityIndicator.hide();

					dialog.addEventListener('click', function(e) {
						Ti.API.info("click : " + e.index + " : " + e.source.ok);
						Ti.App.fireEvent("disconnect_socket");
						var module = require('/mymodules/chat/chat').moduleWindow;
						//Create new instance
						var newWin = new module(bgFile, myindex);
						newWin.open();
						removListenPC();
						containerWin.close();
						chatTV.removeAllChildren();
						myApp.global.removeChildren(containerWin);
						containerWin = null;
					});
				}
			} catch(e) {
				Ti.API.info("ERROR REGISTRATION : " + e.message);
				activityIndicator.hide();
			}
		};
		xhr.open('POST', url);
		xhr.send({
			device_id : deviceID,
			app_id : vars.app_id
		});
	}

	/*
	function registerChatUser(nickName, email) {
	activityIndicator.show();
	var url = 'http://utils.infinitemonkeys.mobi/chatserver/action.php?action=registration';
	Ti.API.info('------url  ' + url);
	var xhr = Titanium.Network.createHTTPClient();
	xhr.onerror = function(e) {
	activityIndicator.hide();
	if (this.status == 0) {
	myApp.global.shoutOut(L("Network_Problem"), L("Either_no_connection_found_or_server_did_not_respond_within_allowed_time"));
	} else {
	myApp.global.shoutOut(L('Operation_Fail'), L('Communication_Error'));
	}
	};
	xhr.setTimeout(10000);
	xhr.onload = function(e) {
	Ti.API.info('registre response  ' + this.responseText);
	try {
	if (this.responseText == 1) {
	// create a node room
	Ti.App.fireEvent('create_node_room', {
	app_id : vars.app_id,
	device_id : uuid
	});
	containerWin.remove(container);
	openChatWindow(nickName, email);

	Ti.App.Properties.setString('chat_name', nickName);
	Ti.App.Properties.setString('chat_address', email);

	// activityIndicator.hide();
	} else if (this.responseText == 2) {
	alert(L("Already_Registered"));
	Ti.API.info("Already REGISTRATION : ");
	activityIndicator.hide();
	}
	} catch(e) {
	Ti.API.info("ERROR REGISTRATION : " + e.message);
	activityIndicator.hide();
	}
	};
	xhr.open('POST', url);
	xhr.send({
	device_id : uuid,
	app_id : vars.app_id,
	email : email,
	user_name : nickName
	});
	}

	// create a function for email validation.
	function checkemail(emailAddress) {
	var str = emailAddress;
	var filter = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
	if (filter.test(str)) {
	results = true;
	} else {
	results = false;
	}
	return (results);
	};*/

	// Write a function to convert time coming from server in to local time.
	var moment = require('mymodules/chat/moment');
	function getLocalTime(utcTime) {
		var millis = utcTime.getTime();
		// convert date coming from server to UTC date formate
		// var utc_date = millis + 4 * 60 * 60 * 1000;
		var utc_date = new Date(millis);
		utc_date = moment(utc_date).format('YYYY-MM-DD HH:mm:ss');
		var localTime = moment.utc(utc_date).toDate();
		localTime = moment(localTime).format('MMM-DD HH:mm');
		localTime = localTime.replace('-', ' ');
		Ti.API.info('server time  ' + utcTime + ', localTime  ' + localTime);
		return localTime;
	}

	return containerWin;
};
