var vScaleFactor = Titanium.Platform.displayCaps.platformHeight / 480;
var iconCount = 0;
var rows = 16;
var cols = 16;
var positions = rows * cols;
var scaleFactor = scaleFactor;
var vars = myApp.global.vars;
var pages = pages;
var icon_scale = vars.icon_scale;
icon_scale = (icon_scale) ? icon_scale : 1;
var iconContainerHeight = 70 * vScaleFactor * icon_scale;
var iconContainerWidth = 50 * vScaleFactor * icon_scale;
var iconBtnSize = 50 * vScaleFactor * icon_scale;
if (Titanium.Platform.displayCaps.platformWidth >= 500) {
	var iconText = 8 * scaleFactor * icon_scale;
} else {
	var iconText = 10 * scaleFactor * icon_scale;
}
//vertical scale factor decides heights of child contents
//if(Titanium.Platform.osname == 'android')
//	menuViewHeight *= 8 / 9;
var menuViewWidth = (300 * scaleFactor);

var menuView = Ti.UI.createView({
	width : menuViewWidth,
	height : myApp.menuViewHeight, //*vScaleFactor/scaleFactor,
	top : myApp.menuViewTop + border,
	left : border * 2,
	zIndex : 9,
	backgroundColor : 'transparent'
});

var menuViewBG = Ti.UI.createImageView({
	// backgroundImage : resDir + "images/home_frame.png",
	backgroundColor : (col_back == undefined) ? 'white' : col_back,
	//borderRadius : 15 * scaleFactor,
	borderWidth : 0,
	opacity : parseFloat(vars.bg_opacity),
	zIndex : 1
});

if (!is_android) {
	menuViewBG.borderColor = '#848484';
}

var colWidth = (menuViewWidth - iconContainerWidth) / cols;
//16th part of width * (12/16)
var rowHeight = (myApp.menuViewHeight - iconContainerHeight) / rows;
Ti.API.info("colwidth: " + colWidth + " - colHeight: " + rowHeight);

//used for tracking bg max/min border.
var minTop = 1000 * vScaleFactor;
//set big to start
var minLeft = 1000 * scaleFactor;
var maxTop = 0;
//set small to start
var maxLeft = 0;
var maxWidth = 0;
//set small to start
var maxHeight = 0;

//default top and left offsets for all containerViews
var topOffset = 0 * vScaleFactor;
var leftOffset = 0 * scaleFactor;
//TODO: reset this back to 10 if needed

//default top and left coordinates for all icons within containerViews
var top = 0;
var left = 0;

Ti.API.info("starting grid layout");

var pos = 0;
//position counter
var myLeft = 0;
var myRight = 0;
var arrIcons = [];
//used for local temp storage of positions

//cycle through all col and row positions, and if there's a corresponding page, add the icon and title.
for (var r = 0; r < rows; r++) {
	for (var c = 0; c < cols; c++) {
		pos += 1;
		//		Ti.API.info(pos);
		for (p in pages) {//have to check each page for each position
			if (pages[p].on = true && pages[p].order == pos) {//if it's on, and the order matches the current position
				Ti.API.info(pages[p].name);
				myLeft = colWidth * c;
				//gridWidth*order%16
				myTop = rowHeight * r;
				//gridHeight*order/16
				Ti.API.info(myLeft + ", " + myTop);

				//create the stuff:
				var containerView = Titanium.UI.createView({
					top : myTop + topOffset,
					width : iconContainerWidth,
					height : iconContainerHeight,
					left : myLeft + leftOffset,
					zIndex : 99, //pages[p].order
					backgroundColor : "transparent",
					myContainerIndex : p
				});

				var iconFile = ( typeof pages[p].icon != 'undefined') ? ExtDir + 'custom/' + pages[p].icon : resDir + 'images/default_button.png';
				var file = Titanium.Filesystem.getFile(iconFile);
				if (!file.exists()) {
					iconFile = ( typeof pages[p].icon != 'undefined') ? resDir + 'custom/' + pages[p].icon : resDir + 'images/default_button.png';
					if (!is_android) {
						var iconiImgFile = ( typeof pages[p].icon != 'undefined') ? 'custom/' + pages[p].icon : 'images/default_button.png';
					}
				}
				var file = Titanium.Filesystem.getFile(iconFile);
				if (!file.exists()) {
					iconFile = 'https://origin-files.infinitemonkeys.mobi/userfiles/' + pages[p].icon;
				} else {
					if (!is_android && !myApp.autoUpdated) {
						iconFile = iconiImgFile;
					}
				}

				Ti.API.info("iconfile: " + iconFile);
				var imgBtn = Titanium.UI.createImageView({
					image : iconFile,
					backgroundColor : "transparent",
					height : iconBtnSize,
					width : iconBtnSize,
					top : 0,
					myindex : p,
					ind : p
				});
				Ti.API.info('height and width' + imgBtn.height + ' ' + imgBtn.width);
				arrIcons.push(imgBtn);
				Ti.API.info("adding listener for: " + p + " - " + pages[p].name);
				imgBtn.addEventListener('click', function(e) {
					Ti.API.info("click");
					var source = e.source;
					menuView.touchEnabled = false;
					source.height = iconBtnSize * 1.2;
					source.width = iconBtnSize * 1.2;
					setTimeout(function() {
						menuView.touchEnabled = true;
						source.height = iconBtnSize;
						source.width = iconBtnSize;
						myApp.menuClick(source.myindex);
					}, 200);

				});
				var titleText = Titanium.UI.createLabel({
					text : pages[p].title,
					//					bottom : 0,
					top : containerView.top + iconBtnSize,
					left : containerView.left - (iconContainerWidth / 2),
					font : {
						fontSize : iconText
					},
					height : Titanium.UI.SIZE, //(iconText + 4) * vScaleFactor,
					width : iconContainerWidth * 2,
					textAlign : 'center',
					//					shadowColor : '#eee',
					//					shadowOffset : {
					//						x : 1,
					//						y : 1
					//					},
					color : vars.col_text
				});

				Ti.API.info("populating containerview");
				containerView.add(imgBtn);
				//				containerView.add(titleText);

				menuView.add(titleText);
				menuView.add(containerView);

				//add coordinates to minTopLeft and MaxTopLeft if they qualify
				minLeft = (myLeft < minLeft) ? myLeft : minLeft;
				//only change it if it's less than the current value
				minTop = (myTop < minTop) ? myTop : minTop;
				if (myLeft >= maxLeft) {
					maxLeft = myLeft;
					maxWidth = (c + 1) * colWidth;
				}
				if (myTop >= maxTop) {
					maxTop = myTop;
					maxHeight = (r + 1) * rowHeight;
				}

			}
		}
	}
}
Ti.API.info("MAX AND MIN for BG");
Ti.API.info("minLeft" + minLeft);
Ti.API.info("minTop" + minTop);
Ti.API.info("maxLeft" + maxLeft);
Ti.API.info("maxTop" + maxTop);
Ti.API.info("maxWidth" + maxWidth);
Ti.API.info("maxHeight" + maxHeight);

menuViewBG.left = minLeft + border;
menuViewBG.top = minTop + myApp.menuViewTop;
menuViewBG.width = maxWidth - minLeft + iconContainerWidth;
menuViewBG.height = maxHeight - minTop + iconContainerHeight;

myApp.container.add(menuViewBG);
myApp.container.add(menuView);

