/**
 * @author mac14
 */

var device_id = Titanium.App.Properties.getString("uuid", '');
// var device_id = Ti.Platform.macaddress;
//var device_id  = "2e14a1b0-f621-4dd1-897c-0dbcef407d67";
Titanium.API.info("deviceid" + device_id);
defaultAvatar = 'images/avatar.png';
var imageURL = "https://origin-files.infinitemonkeys.mobi/modules/community-wall/" + device_id + ".png";
Ti.API.info('image url is', imageURL);
f1 = Titanium.Filesystem.getFile(Titanium.Filesystem.resourcesDirectory, defaultAvatar);
var image = f1.read(image);
defaultAvatar = image;
Ti.API.info('defaultAvator is', defaultAvatar);

var BtnH = deviceHeight * (0.0625);
var scrolly;

function registerScreen(bgImg,titleTxt) {

	var registerWin = Ti.UI.createWindow({
		theme : "Theme.AppCompat.Fullscreen",
	});
	
	registerWin.add(myApp.global.createBackgroundImage());
	scrolly = Titanium.UI.createScrollView({
		top : border,
		contentHeight : deviceHeight - (homeButtonSize + adWindowHeight + padding + 20),
		contentWidth : deviceWidth,
		bottom : (ads_on) ? adWindowHeight + padding : padding,
		left : 0,
		right : 0,
		showHorizontalScrollIndicator : true,
		showVerticalScrollIndicator : true
	});

	var container = myApp.global.createContainer();
	container.bottom = 0;
	container.backgroundColor = "#aaa";
	//	container.opacity = opacity;
	//container.borderRadius = radius;

	var compWidth = deviceWidth * (0.3125);

	var titleLabel = Titanium.UI.createLabel({
		top : 0,
		text : L('Welcome_to_the_community_wall'),
		left : 0,
		color : "#000",
		textAlign : 'center',
		//		backgroundColor : col_back,
		right : 0,
		height : deviceHeight * 0.0834,
		font : {
			fontSize : 12 * scaleFactor,
			fontWeight : 'bold'
		}
	});
	container.add(titleLabel);

	/*
	var nicknameLabel = Titanium.UI.createLabel({
			text : L('Nickname'),
			top : titleLabel.height + titlefont,
			color : col_text,
			left : titlefont,
			height : 28 * scaleFactor,
			width : compWidth,
			font : {
				fontSize : 12 * scaleFactor,
				fontWeight : 'bold'
			}
		});
		container.add(nicknameLabel);*/
	

	var nicknameTxtField = Titanium.UI.createTextField({
		//		color : '#336699',
		height : 28 * scaleFactor,
		hintText : L('Enter_nickname'),
		top : titleLabel.height + titlefont,
		left : titlefont,
		right : titlefont,
		borderStyle : Titanium.UI.INPUT_BORDERSTYLE_ROUNDED,
		font : {
			fontSize : 12 * scaleFactor,
			fontWeight : 'bold'
		},
		color : "#000",
	});
	container.add(nicknameTxtField);

	/*
	var emailLabel = Titanium.UI.createLabel({
			text : L('Email'),
			top : nicknameTxtField.top + nicknameTxtField.height + titlefont,
			left : titlefont,
			color : col_text,
			height : 28 * scaleFactor,
			width : compWidth,
			font : {
				fontSize : 12 * scaleFactor,
				fontWeight : 'bold'
			}
		});
		container.add(emailLabel);*/
	

	var emailTxtField = Titanium.UI.createTextField({
		//		color : '#336699',
		height : 28 * scaleFactor,
		hintText : L("Enter_email"),
		top : nicknameTxtField.top + nicknameTxtField.height + titlefont,
		left : titlefont,
		right : titlefont,
		borderStyle : Titanium.UI.INPUT_BORDERSTYLE_ROUNDED,
		keyboardType : Titanium.UI.KEYBOARD_EMAIL,
		font : {
			fontSize : 12 * scaleFactor,
			fontWeight : 'bold'
		},
		color : "#000",
	});
	container.add(emailTxtField);

	if (is_android) {
		emailTxtField.height = 40 * scaleFactor;
		nicknameTxtField.height = 40 * scaleFactor;
	}

	var chooseImg = Ti.UI.createImageView({
		top : emailTxtField.top + emailTxtField.height + titlefont,
		//		backgroundColor : col_back,
		//		opacity : opacity,
		height : deviceWidth * (0.2344),
		width : deviceWidth * (0.2344),
		left : titlefont,
		image : defaultAvatar
	});
	container.add(chooseImg);

	var chooseBtn = Ti.UI.createButton({
		title : L('Choose_Image'),
		width : deviceWidth * (0.4688),
		height : BtnH,
		top : chooseImg.top + ((chooseImg.height - BtnH) / 2),
		left : compWidth,
		font : {
			fontSize : 12 * scaleFactor,
			fontWeight : 'bold'
		},
		// color : col_title,
	});

	chooseBtn.addEventListener('click', function() {
		// showDialog(chooseImg);
		openPhotoGallary(chooseImg);
	});
	container.add(chooseBtn);

	var submitBtn = Titanium.UI.createButton({
		top : chooseImg.top + chooseImg.height + titlefont,
		left : compWidth,
		width : deviceWidth * (0.2344),
		font : {
			fontSize : 12 * scaleFactor,
			fontWeight : 'bold'
		},
		height : BtnH,
		title : L("Submit"),		
		// color : col_title,
	});
	submitBtn.addEventListener('click', function() {
		submitBtn.enabled = false;
		var mail = emailTxtField.value;

		var name = nicknameTxtField.value.trim();
		var pic = chooseImg.toBlob();

		if (validatePost(name)) {
			if (validateEmail(mail)) {
				uploadRegisterData(pic, name, mail, function() {
					Ti.App.Properties.setString("nick", name);
					Ti.App.Properties.setString("mail", mail);
					isSetting = true;
					isNowSetting = true;
					myApp.WallPostScreen();
					// win.remove(scrolly);
					registerWin.close();
					myApp.global.removeChildren(registerWin);
				});
			}
		} else {
			alert(L("Please_enter_the_nickname"));
		}
		submitBtn.enabled = true;
	});
	container.add(submitBtn);
	Ti.API.info("isSetting : "+ isSetting);
	if (isSetting) {
		nicknameTxtField.value = Titanium.App.Properties.getString("nick");
		emailTxtField.value = Ti.App.Properties.getString("mail");
		// var temp =  'http://infinitemonkeys.mobi/utils/community_wall/avatars/'+device_id+'.png';
		chooseImg.image = chooseImgFilePath;
		//temp.media;

		titleLabel.text = L('Update_your_Profile');
		chooseBtn.title = L('Change_image');
		submitBtn.title = L('Update');		
	}

		var backButton = Titanium.UI.createButton({
			top : chooseImg.top + chooseImg.height + titlefont,
			left : compWidth + submitBtn.width + border,
			title : L('Back'),
			width : deviceWidth * (0.2344),
			font : {
				fontSize : 12 * scaleFactor,
				fontWeight : 'bold'
			},
			height : BtnH,
			// color : col_title,
		});
		container.add(backButton);

		backButton.addEventListener('click', function() {
			// win.remove(scrolly);
			registerWin.close();
			//isSetting = true;
			isNowSetting = true;
			myApp.WallPostScreen();
			refreshImage();
			myApp.global.removeChildren(registerWin);
		});
	//}
	scrolly.add(container);
	registerWin.add(scrolly);
	
	myApp.global.addPageTitle(titleTxt,99,registerWin);
	//myApp.global.addHomeButton();
	myApp.global.makeAdView(registerWin);
	registerWin.open();
}

//code is for trimming
String.prototype.trim = function() {
	return this.replace(/^\s+|\s+$/g, "");
};
//this code is for registration-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
function validateEmail(email) {

	var reg = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
	var address = email;
	if (address == '') {
		myApp.global.shoutOut(L("Oops"), L("Please_enter_your_email"));
		return false;
	}

	if (reg.test(address) == false) {
		myApp.global.shoutOut(L("Oops"), L("Invalid_Email"));
		return false;
	} else {
		return true;
	}
}

/*function showDialog(avatar) {
 var dialog = Titanium.UI.createOptionDialog({
 options : [L("Photo_Gallery"),L('Camera'), L('cancel')],
 cancel : 2
 });
 dialog.show();
 dialog.addEventListener('click', function(e) {
 if (e.index == 0) {
 openPhotoGallary(avatar);
 } else if (e.index == 1) {
 showCamera(avatar);
 }
 });
 }*/

function openPhotoGallary(avatar) {
	try {

		Titanium.Media.openPhotoGallery({
			success : function(event) {
				image = event.media;
				Titanium.API.info('selected image is', image);
				if (event.mediaType == Ti.Media.MEDIA_TYPE_PHOTO) {
					avatar.image = image;
				} else {
					//alertBox.setMessage('You can select only photoes.');
					//alertBox.show();
				}
			},
			mediaTypes : [Ti.Media.MEDIA_TYPE_PHOTO]
		});
	} catch(e) {

	}
}

/*function showCamera(avatar) {
 try {
 Titanium.Media.showCamera({
 success : function(event) {
 image = event.media;
 if (event.mediaType == Ti.Media.MEDIA_TYPE_PHOTO) {
 avatar.image = image;
 } else {
 alert(L('You_can_select_only_photoes'));
 }
 },
 error : function(error) {
 if (error.code == Titanium.Media.NO_CAMERA) {
 alert(L('No_Camera_in_device'));
 }
 },
 saveToPhotoGallery : false,
 mediaTypes : [Ti.Media.MEDIA_TYPE_PHOTO]
 });
 } catch(e) {

 }
 }*/

function uploadRegisterData(image, name, email, updateCallBack) {

	actInd.show();

	//-------UPLOADING IMAGE FILE
	Titanium.API.info(name + email + image + device_id + vars.project_title);
	var url = "https://utils.infinitemonkeys.mobi/community_wall/user_v2.php";
	var xhr = Titanium.Network.createHTTPClient();
	xhr.onerror = function(e) {
		if (this.status == 0) {
			myApp.global.shoutOut(L('Network_Problem'), L('Either_no_connection_found_or_server_did_not_respond_within_allowed_time'));
		} else {
			myApp.global.shoutOut(L('Operation_Fail'), L('Communication_Error'));
		}
	};
	//	xhr.setTimeout(30000);
	xhr.onload = function(e) {
		actInd.hide();
		Ti.API.info('url for uploading user info is', url);
		Ti.API.info('image before update is', image);
		Titanium.API.info("------uploaded avtar------");
		refreshImage();
		updateCallBack();
	};
	xhr.open('POST', url);
	xhr.setRequestHeader("contentType", "multipart/form-data");

	xhr.send({
		name : name,
		email : email,
		app_id : vars.project_title,
		mac_id : device_id,
		media : image,
		filename : device_id
	});
}

var testScreen = function(image) {

	var winTemp = Ti.UI.createWindow({

	});
	var image1 = Ti.UI.createImageView({
		image : image,
		height : 100,
		width : 100
	});
	winTemp.add(image1);
	winTemp.open();
	setTimeout(function() {
		winTemp.close();
	}, 2000);
};
function validatePost(post) {
	if (post != L("Share_something") && post.trim().length > 0) {
		return true;
	} else {
		return false;
	}

}

function refreshImage(data) {
	Ti.API.info("doing refreshImage()");
	var c = Titanium.Network.createHTTPClient();
	c.setTimeout(10000);
	c.onload = function() {
		if (c.status == 200) {
			var filename = 'avatar.png';
			var f = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, filename);
			f.write(this.responseData);
			chooseImgFilePath = f.nativePath;
		}
		if (data != null) {
			myApp.populateTable(data);
			actInd.hide();
			myApp.wallContainer.touchEnabled = true;
		}
	};
	//	c.onerror = function(e) {
	//		Ti.API.info("httpclient error: ");
	//		Ti.API.info(e.error);
	//	}
	Ti.API.info("imageURL = " + imageURL);
	c.open('GET', imageURL);
	c.send();
	
	

}